----------------------------------------------------------------
-----		 AddOn: Ketho CombatLog						--------		----> Insert some Warcraft 3 [Steam Tank] ASCII Art here ! <----
-----		Author: Ketho (EU-Boulderfist Alliance CHN) --------		   http://classic.battle.net/war3/human/units/siegeengine.shtml
-----	   Created: 2009.09.01 (1 September 2009)		--------
-----  Text Editor: Notepad++							--------	http://notepad-plus.sourceforge.net/
------ # Version -----------------------------------------------
-----  Ketho CombatLog				 v0.90 [2010.11.29] --------	http://wow.curse.com/downloads/wow-addons/details/ketho-combat.aspx
-----  Ace3 Development Framework	  r981 [2010.10.27] --------	http://wow.curse.com/downloads/wow-addons/details/ace3.aspx
------ # Features ----------------------------------------------
-----  01  Customizable CombatLog						--------
------ # Index -------------------------------------------------
-----  01  UPVALUES										--------	Line	26
-----  02  OPTIONS AND DEFAULT VARIABLES				--------	Line   116
-----  03  OnInitialize, OnEnable, OnDisable			--------	Line   884
-----  04  CALLBACK HANDLERS							--------	Line   935
-----  05  EVENT HANDLERS								--------	Line  1123
----------------------------------------------------------------
-- Note: This is my 1st AddOn
-- I don't have any previous programming experience/background in any language

KethoCombatLog = LibStub("AceAddon-3.0"):NewAddon("KethoCombatLog", "AceConsole-3.0", "AceEvent-3.0", "AceTimer-3.0") -- Instance of AceAddon Class http://www.wowace.com/addons/ace3/pages/api/ace-addon-3-0/
local KCL = KethoCombatLog -- abbreviated/upvalued; this points to the same "table object"
local L = LibStub("AceLocale-3.0"):GetLocale("KethoCombatLogLocale", true) -- http://www.wowace.com/addons/ace3/pages/api/ace-locale-3-0/

	-----------------------------------------------
	-----  01  UPVALUES -----
	-----------------------------------------------
-- Lua functions -- http://www.wowpedia.org/Lua_functions  /  http://www.lua.org/manual/5.1/
local _G = _G -- global table
local print, tonumber, select, date = _G.print, _G.tonumber, _G.select, _G.date -- os.date (mirror)
local format, gsub, strfind, strlen, strtrim = _G.format, _G.gsub, _G.strfind, _G.strlen, _G.strtrim -- string.format, string.gsub, string.find, string.len, string.trim (WoW Lua)
local band = _G.bit.band -- BitLib library
-- WoW API -- http://www.wowpedia.org/World_of_Warcraft_API
local GetTime = GetTime
local UnitName, UnitClass = UnitName, UnitClass
local UnitInParty, UnitInRaid = UnitInParty, UnitInRaid
local UnitGroupRolesAssigned = UnitGroupRolesAssigned
local IsInInstance = IsInInstance
local SCM = SendChatMessage
-- Spell School Strings (prevents global table lookups at every CLEU)
local STRING_SCHOOL_PHYSICAL = STRING_SCHOOL_PHYSICAL
local STRING_SCHOOL_HOLY = STRING_SCHOOL_HOLY
local STRING_SCHOOL_FIRE = STRING_SCHOOL_FIRE
local STRING_SCHOOL_NATURE = STRING_SCHOOL_NATURE
local STRING_SCHOOL_FROST = STRING_SCHOOL_FROST
local STRING_SCHOOL_SHADOW = STRING_SCHOOL_SHADOW
local STRING_SCHOOL_ARCANE = STRING_SCHOOL_ARCANE
local STRING_SCHOOL_HOLYSTRIKE = STRING_SCHOOL_HOLYSTRIKE
local STRING_SCHOOL_FLAMESTRIKE = STRING_SCHOOL_FLAMESTRIKE
local STRING_SCHOOL_HOLYFIRE = STRING_SCHOOL_HOLYFIRE
local STRING_SCHOOL_STORMSTRIKE = STRING_SCHOOL_STORMSTRIKE
local STRING_SCHOOL_HOLYSTORM = STRING_SCHOOL_HOLYSTORM
local STRING_SCHOOL_FIRESTORM = STRING_SCHOOL_FIRESTORM
local STRING_SCHOOL_FROSTSTRIKE = STRING_SCHOOL_FROSTSTRIKE
local STRING_SCHOOL_HOLYFROST = STRING_SCHOOL_HOLYFROST
local STRING_SCHOOL_FROSTFIRE = STRING_SCHOOL_FROSTFIRE
local STRING_SCHOOL_FROSTSTORM = STRING_SCHOOL_FROSTSTORM
local STRING_SCHOOL_SHADOWSTRIKE = STRING_SCHOOL_SHADOWSTRIKE
local STRING_SCHOOL_SHADOWLIGHT = STRING_SCHOOL_SHADOWLIGHT -- "Twilight"
local STRING_SCHOOL_SHADOWFLAME = STRING_SCHOOL_SHADOWFLAME
local STRING_SCHOOL_SHADOWSTORM = STRING_SCHOOL_SHADOWSTORM -- "Plague"
local STRING_SCHOOL_SHADOWFROST = STRING_SCHOOL_SHADOWFROST
local STRING_SCHOOL_SPELLSTRIKE = STRING_SCHOOL_SPELLSTRIKE
local STRING_SCHOOL_DIVINE = STRING_SCHOOL_DIVINE
local STRING_SCHOOL_SPELLFIRE = STRING_SCHOOL_SPELLFIRE	
local STRING_SCHOOL_SPELLSTORM = STRING_SCHOOL_SPELLSTORM
local STRING_SCHOOL_SPELLFROST = STRING_SCHOOL_SPELLFROST
local STRING_SCHOOL_SPELLSHADOW = STRING_SCHOOL_SPELLSHADOW
local STRING_SCHOOL_ELEMENTAL = STRING_SCHOOL_ELEMENTAL
local STRING_SCHOOL_CHROMATIC = STRING_SCHOOL_CHROMATIC
local STRING_SCHOOL_MAGIC = STRING_SCHOOL_MAGIC
local STRING_SCHOOL_CHAOS = STRING_SCHOOL_CHAOS
local STRING_SCHOOL_UNKNOWN = STRING_SCHOOL_UNKNOWN
-- UnitFlags Masks -- http://www.wowpedia.org/UnitFlag
local COMBATLOG_OBJECT_REACTION_FRIENDLY = COMBATLOG_OBJECT_REACTION_FRIENDLY -- 16(decimal) == 01000000(binary)
--local COMBATLOG_OBJECT_REACTION_NEUTRAL = COMBATLOG_OBJECT_REACTION_NEUTRAL -- 32(decimal) == 00100000(binary)
local COMBATLOG_OBJECT_REACTION_HOSTILE = COMBATLOG_OBJECT_REACTION_HOSTILE -- 64(decimal) == 00010000(binary)
local COMBATLOG_OBJECT_RAIDTARGET1 = COMBATLOG_OBJECT_RAIDTARGET1 -- 1048576(decimal)	== 100000000000000000000(binary)
local COMBATLOG_OBJECT_RAIDTARGET2 = COMBATLOG_OBJECT_RAIDTARGET2 -- 2097152(decimal)	== 1000000000000000000000(binary)
local COMBATLOG_OBJECT_RAIDTARGET3 = COMBATLOG_OBJECT_RAIDTARGET3 -- 4194304(decimal)	== 10000000000000000000000(binary)
local COMBATLOG_OBJECT_RAIDTARGET4 = COMBATLOG_OBJECT_RAIDTARGET4 -- 8388608(decimal)	== 100000000000000000000000(binary)
local COMBATLOG_OBJECT_RAIDTARGET5 = COMBATLOG_OBJECT_RAIDTARGET5 -- 16777216(decimal)	== 1000000000000000000000000(binary)
local COMBATLOG_OBJECT_RAIDTARGET6 = COMBATLOG_OBJECT_RAIDTARGET6 -- 33554432(decimal)	== 10000000000000000000000000(binary)
local COMBATLOG_OBJECT_RAIDTARGET7 = COMBATLOG_OBJECT_RAIDTARGET7 -- 67108864(decimal)	== 100000000000000000000000000(binary)
local COMBATLOG_OBJECT_RAIDTARGET8 = COMBATLOG_OBJECT_RAIDTARGET8 -- 134217728(decimal)	== 1000000000000000000000000000(binary)
-- GlobalStrings.lua variables for in CLEU event handler -- http://wowprogramming.com/utils/xmlbrowser/test/FrameXML/GlobalStrings.lua
local YOU, MELEE, PVP = YOU, MELEE, PVP
local QUICKBUTTON_NAME_SELF = QUICKBUTTON_NAME_SELF
local ACTION_UNIT_DIED = ACTION_UNIT_DIED
local TEXT_MODE_A_STRING_RESULT_CRITICAL = TEXT_MODE_A_STRING_RESULT_CRITICAL
local TEXT_MODE_A_STRING_RESULT_CRUSHING = TEXT_MODE_A_STRING_RESULT_CRUSHING
--# File-local Scope variables
local CF -- ChatFrame
local playerName = UnitName("player")
local _, playerClass = UnitClass("player"); local playerColor
local englishPlayerFaction = UnitFactionGroup("player") -- for addon icon MountainKing/BladeMaster
local instanceType, announceType, lastDeath
-- Cooldown / Throttle
local cd_instanceType = 0; local cd_Death = 0; local cd_RitualRefreshment = 0; local cd_Bloodlust = 0; local timeSilence = 0
-- Upvalued Options
local optionsTaunt, optionsInterrupt, optionsDispel, optionsReflect, optionsDeath, optionsResurrection, optionsCrowdControl, optionsCC_Break
local optionsTankTaunt, optionsTankBreaksCC, optionsPetGrowl
local combatPvE, combatPvP, combatWorld
local optionsChatFrame, optionsChatChannel
local optionsIconSize, optionsIconCropped, optionsTimestamp
local optionsFeast, optionsRepairBot, optionsFun
local optionsInnervate, optionsMisdirection, optionsFocusMagic, optionsTricksTrade, optionsSoulstoneResurrection, optionsVigilance, optionsBloodlust, optionsRitualRefreshment, optionsMindVision
local iconCropped = "64:64:4:60:4:60" -- http://www.wowpedia.org/UI_escape_sequences
-- Upvalued Colors (Hex)
local hexTaunt, hexInterrupt, hexReflect, hexDispel, hexCrowdControl, hexCC_Break, hexDeath, hexResurrection
local hexPhysical, hexHoly, hexFire, hexNature, hexFrost, hexShadow, hexArcane; --local hexPhysical = "FFFF00"
local hexDeathKnight, hexDruid, hexHunter, hexMage, hexPaladin, hexPriest, hexRogue, hexShaman, hexWarlock, hexWarrior
local hexFriendlyReaction, hexHostileReaction, hexUnknownReaction

	-----------------------------------------------
	-----  02  OPTIONS AND DEFAULT VARIABLES  -----
	-----------------------------------------------
--- Blizzard GUI Options --- http://www.wowace.com/addons/ace3/pages/ace-config-3-0-options-tables/
local options = {
	type = "group",
	name = "",
	args = {
		optionsMain = {
			type = "group",
			name = "\124cffADFF2FKetho\124r |cffFFFFFFCombatLog|r |cffB6CA00v0.90|r                         |cffFFFFFF2010.11.29|r", -- Main Options Header
			handler = KCL,
			args = {
				toggleEnableAddOn = {
					type = "toggle",
					order = 1,
					width = "full",
					descStyle = "",
					name = "|cffFFFFFFEnable AddOn|r",
					get = function(info) return KCL.db.profile.enableAddOn end,
					set = function(info, value) KCL.db.profile.enableAddOn = value
						if KCL.db.profile.enableAddOn == true then KCL:Enable() -- Turn AddOn on
						elseif KCL.db.profile.enableAddOn == false then KCL:Disable() -- Turn AddOn off
						end; end,
				},
				toggleTaunt = {
					type = "toggle",
					order = 2,
					name = function() return "|TInterface\\Icons\\Spell_Nature_Reincarnation:24:24:1:0:"..iconCropped.."|t  |cff"..KCL_Dec2Hex(KCL.db.profile.colorTaunt.r,KCL.db.profile.colorTaunt.g,KCL.db.profile.colorTaunt.b).."Taunts|r" end,
					descStyle = "",
					disabled = "OptionsDisabled",
					get = function(info) return KCL.db.profile.Taunt end,
					set = function(info, value) KCL.db.profile.Taunt = value; KCL_upvaluedOptions() end,
				},
				toggleInterrupt = {
					type = "toggle",
					order = 4,
					name = function() return "|TInterface\\Icons\\Ability_Kick:24:24:1:0:"..iconCropped.."|t  |cff"..KCL_Dec2Hex(KCL.db.profile.colorInterrupt.r,KCL.db.profile.colorInterrupt.g,KCL.db.profile.colorInterrupt.b).."Interrupts|r" end,
					descStyle = "",
					disabled = "OptionsDisabled",
					get = function(info) return KCL.db.profile.Interrupt end,
					set = function(info, value) KCL.db.profile.Interrupt = value; KCL_upvaluedOptions() end,
				},
				toggleDispel = {
					type = "toggle",
					order = 6,
					name = function() return "|TInterface\\Icons\\Spell_Holy_DispelMagic:24:24:1:0:"..iconCropped.."|t  |cff"..KCL_Dec2Hex(KCL.db.profile.colorDispel.r,KCL.db.profile.colorDispel.g,KCL.db.profile.colorDispel.b).."Dispels|r" end,
					descStyle = "",
					disabled = "OptionsDisabled",
					get = function(info) return KCL.db.profile.Dispel end,
					set = function(info, value) KCL.db.profile.Dispel = value; KCL_upvaluedOptions() end,
				},
				toggleReflect = {
					type = "toggle",
					order = 8,
					name = function() return "|TInterface\\Icons\\Ability_Warrior_ShieldReflection:24:24:1:0:"..iconCropped.."|t  |cff"..KCL_Dec2Hex(KCL.db.profile.colorReflect.r,KCL.db.profile.colorReflect.g,KCL.db.profile.colorReflect.b).."Reflects|r" end,
					descStyle = "",
					disabled = "OptionsDisabled",
					get = function(info) return KCL.db.profile.Reflect end,
					set = function(info, value) KCL.db.profile.Reflect = value; KCL_upvaluedOptions() end,
				},
				toggleCrowdControl = {
					type = "toggle",
					order = 3,
					name = function() return "|TInterface\\Icons\\Spell_Nature_Polymorph:24:24:1:0:"..iconCropped.."|t  |cff"..KCL_Dec2Hex(KCL.db.profile.colorCrowdControl.r,KCL.db.profile.colorCrowdControl.g,KCL.db.profile.colorCrowdControl.b).."Crowd Control|r" end,
					descStyle = "",
					disabled = "OptionsDisabled",
					get = function(info) return KCL.db.profile.CrowdControl end,
					set = function(info, value) KCL.db.profile.CrowdControl = value; KCL_upvaluedOptions() end,
				},
				toggleCC_Break = {
					type = "toggle",
					order = 6,
					name = function() return "|TInterface\\Icons\\Ability_Seal:24:24:1:0:"..iconCropped.."|t  |cff"..KCL_Dec2Hex(KCL.db.profile.colorCC_Break.r,KCL.db.profile.colorCC_Break.g,KCL.db.profile.colorCC_Break.b).."CC Breaker|r" end,
					descStyle = "",
					disabled = "OptionsDisabled",
					get = function(info) return KCL.db.profile.CC_Break end,
					set = function(info, value) KCL.db.profile.CC_Break = value; KCL_upvaluedOptions() end,
				},
				toggleDeath = {
					type = "toggle",
					order = 7,
					name = function() return "|TInterface\\Icons\\Ability_Rogue_FeignDeath:24:24:1:0:"..iconCropped.."|t  |cff"..KCL_Dec2Hex(KCL.db.profile.colorDeath.r,KCL.db.profile.colorDeath.g,KCL.db.profile.colorDeath.b).."Deaths|r" end,
					descStyle = "",
					disabled = "OptionsDisabled",
					get = function(info) return KCL.db.profile.Death end,
					set = function(info, value) KCL.db.profile.Death = value; KCL_upvaluedOptions() end,
				},
				toggleResurrection = {
					type = "toggle",
					order = 9,
					name = function() return "|TInterface\\Icons\\Spell_Holy_Resurrection:24:24:1:0:"..iconCropped.."|t  |cff"..KCL_Dec2Hex(KCL.db.profile.colorResurrection.r,KCL.db.profile.colorResurrection.g,KCL.db.profile.colorResurrection.b).."Resurrections|r" end,
					descStyle = "",
					disabled = "OptionsDisabled",
					get = function(info) return KCL.db.profile.Resurrection end,
					set = function(info, value) KCL.db.profile.Resurrection = value; KCL_upvaluedOptions() end,
				},
				header01 = {
					type = "header",
					order = 10,
					name = "",
				},
				toggleCombatPvE = {
					type = "toggle",
					order = 11,
					descStyle = "",
					name = "  |cffA8A8FFPvE|r", -- /dump ChatTypeInfo.PARTY {r = 0.666, g = 0.666, b = 1.000}
					get = function(info) return KCL.db.profile.combatPvE end,
					set = function(info, value) KCL.db.profile.combatPvE = value; KCL_upvaluedOptions() end,
					disabled = "OptionsDisabled",
				},
				toggleCombatPvP = {
					type = "toggle",
					order = 13,
					descStyle = "",
					name = "  |cffFF7F00"..PVP.."|r", -- /dump ChatTypeInfo.RAID {r = 1.000, g = 0.498, b = 0.000}
					get = function(info) return KCL.db.profile.combatPvP end,
					set = function(info, value) KCL.db.profile.combatPvP = value; KCL_upvaluedOptions() end,
					disabled = "OptionsDisabled",
				},
				toggleCombatWorld = {
					type = "toggle",
					order = 15,
					descStyle = "",
					name = "  World",
					get = function(info) return KCL.db.profile.combatWorld end,
					set = function(info, value) KCL.db.profile.combatWorld = value; KCL_upvaluedOptions() end,
					disabled = "OptionsDisabled",
				},
				toggleTankTaunt = {
					type = "toggle",
					order = 12,
					descStyle = "",
					name = function() return "|TInterface\\LFGFRAME\\UI-LFG-ICON-ROLES:28:28:-3:0:256:256:1:65:68:132|t|TInterface\\Icons\\Spell_Nature_Reincarnation:24:24:0:0:"..iconCropped.."|t |cff6FAFE6"..TANK.."|r |cff"..KCL_Dec2Hex(KCL.db.profile.colorTaunt.r,KCL.db.profile.colorTaunt.g,KCL.db.profile.colorTaunt.b).."Taunts|r" end,
					get = function(info) return KCL.db.profile.tankTaunt end,
					set = function(info, value) KCL.db.profile.tankTaunt = value; KCL_upvaluedOptions() end,
					disabled = function() if KCL.db.profile.Taunt == false or KCL.db.profile.enableAddOn == false then return true end; end,
				},
				toggleTankBreaksCC = {
					type = "toggle",
					order = 14,
					descStyle = "",
					name = function() return "|TInterface\\LFGFRAME\\UI-LFG-ICON-ROLES:28:28:-3:0:256:256:1:65:68:132|t|TInterface\\Icons\\Ability_Seal:24:24:0:0:"..iconCropped.."|t |cff6FAFE6"..TANK.."|r |cff"..KCL_Dec2Hex(KCL.db.profile.colorCC_Break.r,KCL.db.profile.colorCC_Break.g,KCL.db.profile.colorCC_Break.b).."CC Breaks|r" end,
					get = function(info) return KCL.db.profile.tankBreaksCC end,
					set = function(info, value) KCL.db.profile.tankBreaksCC = value; KCL_upvaluedOptions() end,
					disabled = function() if KCL.db.profile.CC_Break == false or KCL.db.profile.enableAddOn == false then return true end; end,
				},
				togglePetGrowl = {
					type = "toggle",
					order = 16,
					descStyle = "",
					name = function() return " |TInterface\\Icons\\INV_Weapon_Bow_07:24:24:-4:0:"..iconCropped.."|t|TInterface\\Icons\\Ability_Physical_Taunt:24:24:1:0:"..iconCropped.."|t  |cffABD473"..PET.."|r |cff"..KCL_Dec2Hex(KCL.db.profile.colorTaunt.r,KCL.db.profile.colorTaunt.g,KCL.db.profile.colorTaunt.b).."Growl|r" end,
					get = function(info) return KCL.db.profile.petGrowl end,
					set = function(info, value) KCL.db.profile.petGrowl = value; KCL_upvaluedOptions() end,
					disabled = function() if KCL.db.profile.Taunt == false or KCL.db.profile.enableAddOn == false then return true end; end,
				},
				header02 = {
					type = "header",
					order = 17,
					name = "",
				},
				selectChatFrame = {
					type = "select",
					order = 18,
					name = "   |cffFFFFFFChat Frame|r",
					descStyle = "",
					values = function() local ChatFrameList = {}
						ChatFrameList[1] = "|cffFF0000"..ADDON_DISABLED.."|r"
						for i = 1, NUM_CHAT_WINDOWS do
							local a = GetChatWindowInfo(i)
							if a ~= "" then ChatFrameList[i+1] = "|cff2E9AFE"..i..".|r  "..select(1, GetChatWindowInfo(i)) end
						end
						return ChatFrameList end,
					get = function(info) return KCL.db.char.chatFrame end,
					set = function(info, value) KCL.db.char.chatFrame = value; KCL_upvaluedOptions() -- hack: use 10 instead and hope nobody uses the full 10 chatframes; all those CF:AddMesage() depends on the CF, how would i disable it without giving errors without massive if-then-blocks ?! ><
						if KCL.db.char.chatFrame > 1 then CF = _G["ChatFrame"..KCL.db.char.chatFrame-1]; CF:AddMessage("|cffADFF2FKetho CombatLog|r: Chat Frame |cff57A3FF"..(KCL.db.char.chatFrame-1)..".|r |cffADFF2F"..select(1,GetChatWindowInfo(KCL.db.char.chatFrame-1)).."|r") end; end,
					disabled = "OptionsDisabled",
				},
				selectChatChannel = {
					type = "select",
					order = 19,
					name = "   |cffFFFFFFChat Channel|r",
					descStyle = "",
					values = function() local ChatChannelList = {};
						ChatChannelList[1] = "|cffFF0000"..ADDON_DISABLED.."|r"
						ChatChannelList[2] = "|cffA8A8FF"..PARTY.."|r / |cffFF7F00"..RAID.."|r"
						for i = 1, 10 do
							local a = select((i*2)-1, GetChannelList()) -- this is was kinda hard to code, seeing how GetChannelList() works..
							if a then ChatChannelList[a+2] = "|cff2E9AFE"..a..".|r  "..select(i*2,GetChannelList()) end
						end
						return ChatChannelList end,
					get = function(info) return KCL.db.char.chatChannel end,
					set = function(info, value) KCL.db.char.chatChannel = value; KCL_upvaluedOptions() end,
				},
			},
		},
		optionsAdvanced = {
			type = "group",
			name = "",
			handler = KCL,
			args = {
				groupColoring = {
					type = "group",
					order = 1,
					name = "|TInterface\\Icons\\INV_Misc_Gem_Variety_02:20:20:1:0:"..iconCropped.."|t  |cffC6DC00Col|r|cff57A3FFori|r|cffF6ADC6ng|r",
					args = {
						colorTaunt = {
							type = "color",
							order = 1,
							name = "|TInterface\\Icons\\Spell_Nature_Reincarnation:20:20:1:0:"..iconCropped.."|t  Taunts",
							get = function(info) return KCL.db.profile.colorTaunt.r, KCL.db.profile.colorTaunt.g, KCL.db.profile.colorTaunt.b end,
							set = function(info, r,g,b) KCL.db.profile.colorTaunt.r = r; KCL.db.profile.colorTaunt.g = g; KCL.db.profile.colorTaunt.b = b; KCL_upvaluedOptionsHex() end,
						},
						colorInterrupt = {
							type = "color",
							order = 2,
							name = "|TInterface\\Icons\\Ability_Kick:20:20:1:0:"..iconCropped.."|t  "..INTERRUPTS,
							get = function(info) return KCL.db.profile.colorInterrupt.r, KCL.db.profile.colorInterrupt.g, KCL.db.profile.colorInterrupt.b end,
							set = function(info, r,g,b) KCL.db.profile.colorInterrupt.r = r; KCL.db.profile.colorInterrupt.g = g; KCL.db.profile.colorInterrupt.b = b; KCL_upvaluedOptionsHex() end,
						},
						colorDispel = {
							type = "color",
							order = 3,
							name = "|TInterface\\Icons\\Spell_Holy_DispelMagic:20:20:1:0:"..iconCropped.."|t  "..DISPELS,
							get = function(info) return KCL.db.profile.colorDispel.r, KCL.db.profile.colorDispel.g, KCL.db.profile.colorDispel.b end,
							set = function(info, r,g,b) KCL.db.profile.colorDispel.r = r; KCL.db.profile.colorDispel.g = g; KCL.db.profile.colorDispel.b = b; KCL_upvaluedOptionsHex() end,
						},
						colorReflect = {
							type = "color",
							order = 4,
							name = "|TInterface\\Icons\\Ability_Warrior_ShieldReflection:20:20:1:0:"..iconCropped.."|t  Reflects",
							get = function(info) return KCL.db.profile.colorReflect.r, KCL.db.profile.colorReflect.g, KCL.db.profile.colorReflect.b end,
							set = function(info, r,g,b) KCL.db.profile.colorReflect.r = r; KCL.db.profile.colorReflect.g = g; KCL.db.profile.colorReflect.b = b; KCL_upvaluedOptionsHex() end,
						},
						colorCrowdControl = {
							type = "color",
							order = 5,
							name = "|TInterface\\Icons\\Spell_Nature_Polymorph:20:20:1:0:"..iconCropped.."|t  Crowd Control",
							get = function(info) return KCL.db.profile.colorCrowdControl.r, KCL.db.profile.colorCrowdControl.g, KCL.db.profile.colorCrowdControl.b end,
							set = function(info, r,g,b) KCL.db.profile.colorCrowdControl.r = r; KCL.db.profile.colorCrowdControl.g = g; KCL.db.profile.colorCrowdControl.b = b; KCL_upvaluedOptionsHex() end,
						},
						colorCC_Break = {
							type = "color",
							order = 6,
							name = "|TInterface\\Icons\\Ability_Seal:20:20:1:0:"..iconCropped.."|t  CC Breaker",
							get = function(info) return KCL.db.profile.colorCC_Break.r, KCL.db.profile.colorCC_Break.g, KCL.db.profile.colorCC_Break.b end,
							set = function(info, r,g,b) KCL.db.profile.colorCC_Break.r = r; KCL.db.profile.colorCC_Break.g = g; KCL.db.profile.colorCC_Break.b = b; KCL_upvaluedOptionsHex() end,
						},
						colorDeath = {
							type = "color",
							order = 7,
							name = "|TInterface\\Icons\\Ability_Rogue_FeignDeath:20:20:1:0:"..iconCropped.."|t  "..DEATHS,
							get = function(info) return KCL.db.profile.colorDeath.r, KCL.db.profile.colorDeath.g, KCL.db.profile.colorDeath.b end,
							set = function(info, r,g,b) KCL.db.profile.colorDeath.r = r; KCL.db.profile.colorDeath.g = g; KCL.db.profile.colorDeath.b = b; KCL_upvaluedOptionsHex() end,
						},
						colorResurrection = {
							type = "color",
							order = 8,
							name = "|TInterface\\Icons\\Spell_Holy_Resurrection:20:20:1:0:"..iconCropped.."|t  "..RESURRECT,
							get = function(info) return KCL.db.profile.colorResurrection.r, KCL.db.profile.colorResurrection.g, KCL.db.profile.colorResurrection.b end,
							set = function(info, r,g,b) KCL.db.profile.colorResurrection.r = r; KCL.db.profile.colorResurrection.g = g; KCL.db.profile.colorResurrection.b = b; KCL_upvaluedOptionsHex() end,
						},
						description01 = {
							type = "description",
							order = 9,
							name = " ",
						},
						colorPhysicalSpellSchool = {
							type = "color",
							order = 10,
							name = "|TInterface\\Icons\\Spell_Nature_Strength:20:20:1:0:"..iconCropped.."|t  "..STRING_SCHOOL_PHYSICAL,
							get = function(info) return KCL.db.profile.colorPhysicalSpellSchool.r, KCL.db.profile.colorPhysicalSpellSchool.g, KCL.db.profile.colorPhysicalSpellSchool.b end,
							set = function(info, r,g,b) KCL.db.profile.colorPhysicalSpellSchool.r = r; KCL.db.profile.colorPhysicalSpellSchool.g = g; KCL.db.profile.colorPhysicalSpellSchool.b = b; KCL_upvaluedOptionsHex() end,
						},
						colorHolySpellSchool = {
							type = "color",
							order = 11,
							name = "|TInterface\\PaperDollInfoFrame\\SpellSchoolIcon2:22:22:1:0:16:16:1:15:1:15|t  "..STRING_SCHOOL_HOLY,
							get = function(info) return KCL.db.profile.colorHolySpellSchool.r, KCL.db.profile.colorHolySpellSchool.g, KCL.db.profile.colorHolySpellSchool.b end,
							set = function(info, r,g,b) KCL.db.profile.colorHolySpellSchool.r = r; KCL.db.profile.colorHolySpellSchool.g = g; KCL.db.profile.colorHolySpellSchool.b = b; KCL_upvaluedOptionsHex() end,
						},
						colorFireSpellSchool = {
							type = "color",
							order = 12,
							name = "|TInterface\\PaperDollInfoFrame\\SpellSchoolIcon3:22:22:1:0:16:16:1:15:1:15|t  "..STRING_SCHOOL_FIRE,
							get = function(info) return KCL.db.profile.colorFireSpellSchool.r, KCL.db.profile.colorFireSpellSchool.g, KCL.db.profile.colorFireSpellSchool.b end,
							set = function(info, r,g,b) KCL.db.profile.colorFireSpellSchool.r = r; KCL.db.profile.colorFireSpellSchool.g = g; KCL.db.profile.colorFireSpellSchool.b = b; KCL_upvaluedOptionsHex() end,
						},
						colorNatureSpellSchool = {
							type = "color",
							order = 13,
							name = "|TInterface\\PaperDollInfoFrame\\SpellSchoolIcon4:22:22:1:0:16:16:1:15:1:15|t  "..STRING_SCHOOL_NATURE,
							get = function(info) return KCL.db.profile.colorNatureSpellSchool.r, KCL.db.profile.colorNatureSpellSchool.g, KCL.db.profile.colorNatureSpellSchool.b end,
							set = function(info, r,g,b) KCL.db.profile.colorNatureSpellSchool.r = r; KCL.db.profile.colorNatureSpellSchool.g = g; KCL.db.profile.colorNatureSpellSchool.b = b; KCL_upvaluedOptionsHex() end,
						},
						colorFrostSpellSchool = {
							type = "color",
							order = 14,
							name = "|TInterface\\PaperDollInfoFrame\\SpellSchoolIcon5:22:22:1:0:16:16:1:15:1:15|t  "..STRING_SCHOOL_FROST,
							get = function(info) return KCL.db.profile.colorFrostSpellSchool.r, KCL.db.profile.colorFrostSpellSchool.g, KCL.db.profile.colorFrostSpellSchool.b end,
							set = function(info, r,g,b) KCL.db.profile.colorFrostSpellSchool.r = r; KCL.db.profile.colorFrostSpellSchool.g = g; KCL.db.profile.colorFrostSpellSchool.b = b; KCL_upvaluedOptionsHex() end,
						},
						colorShadowSpellSchool = {
							type = "color",
							order = 15,
							name = "|TInterface\\PaperDollInfoFrame\\SpellSchoolIcon6:22:22:1:0:16:16:1:15:1:15|t  "..STRING_SCHOOL_SHADOW,
							get = function(info) return KCL.db.profile.colorShadowSpellSchool.r, KCL.db.profile.colorShadowSpellSchool.g, KCL.db.profile.colorShadowSpellSchool.b end,
							set = function(info, r,g,b) KCL.db.profile.colorShadowSpellSchool.r = r; KCL.db.profile.colorShadowSpellSchool.g = g; KCL.db.profile.colorShadowSpellSchool.b = b; KCL_upvaluedOptionsHex() end,
						},
						colorArcaneSpellSchool = {
							type = "color",
							order = 16,
							name = "|TInterface\\PaperDollInfoFrame\\SpellSchoolIcon7:22:22:1:0:16:16:1:15:1:15|t  "..STRING_SCHOOL_ARCANE,
							get = function(info) return KCL.db.profile.colorArcaneSpellSchool.r, KCL.db.profile.colorArcaneSpellSchool.g, KCL.db.profile.colorArcaneSpellSchool.b end,
							set = function(info, r,g,b) KCL.db.profile.colorArcaneSpellSchool.r = r; KCL.db.profile.colorArcaneSpellSchool.g = g; KCL.db.profile.colorArcaneSpellSchool.b = b; KCL_upvaluedOptionsHex() end,
						},
						description02 = {
							type = "description",
							order = 17,
							name = " ",
						},
						colorDeathKnight = {
							type = "color",
							order = 18,
							name = "|TInterface\\GLUES\\CHARACTERCREATE\\UI-CHARACTERCREATE-CLASSES:20:20:1:0:256:256:68:124:133:189|t  Death Knight",
							get = function(info) return KCL.db.profile.colorDeathKnight.r, KCL.db.profile.colorDeathKnight.g, KCL.db.profile.colorDeathKnight.b end,
							set = function(info, r,g,b) KCL.db.profile.colorDeathKnight.r = r; KCL.db.profile.colorDeathKnight.g = g; KCL.db.profile.colorDeathKnight.b = b; KCL_upvaluedOptionsHex() end,
						},
						colorDruid = {
							type = "color",
							order = 19,
							name = "|TInterface\\GLUES\\CHARACTERCREATE\\UI-CHARACTERCREATE-CLASSES:20:20:1:0:256:256:194:250:4:60|t  Druid",
							get = function(info) return KCL.db.profile.colorDruid.r, KCL.db.profile.colorDruid.g, KCL.db.profile.colorDruid.b end,
							set = function(info, r,g,b) KCL.db.profile.colorDruid.r = r; KCL.db.profile.colorDruid.g = g; KCL.db.profile.colorDruid.b = b; KCL_upvaluedOptionsHex() end,
						},
						colorHunter = {
							type = "color",
							order = 20,
							name = "|TInterface\\GLUES\\CHARACTERCREATE\\UI-CHARACTERCREATE-CLASSES:20:20:1:0:256:256:4:60:68:124|t  Hunter",
							get = function(info) return KCL.db.profile.colorHunter.r, KCL.db.profile.colorHunter.g, KCL.db.profile.colorHunter.b end,
							set = function(info, r,g,b) KCL.db.profile.colorHunter.r = r; KCL.db.profile.colorHunter.g = g; KCL.db.profile.colorHunter.b = b; KCL_upvaluedOptionsHex() end,
						},
						colorMage = {
							type = "color",
							order = 21,
							name = "|TInterface\\GLUES\\CHARACTERCREATE\\UI-CHARACTERCREATE-CLASSES:20:20:1:0:256:256:68:124:4:60|t  Mage",
							get = function(info) return KCL.db.profile.colorMage.r, KCL.db.profile.colorMage.g, KCL.db.profile.colorMage.b end,
							set = function(info, r,g,b) KCL.db.profile.colorMage.r = r; KCL.db.profile.colorMage.g = g; KCL.db.profile.colorMage.b = b; KCL_upvaluedOptionsHex() end,
						},
						colorPaladin = {
							type = "color",
							order = 22,
							name = "|TInterface\\GLUES\\CHARACTERCREATE\\UI-CHARACTERCREATE-CLASSES:20:20:1:0:256:256:4:60:132:188|t  Paladin",
							get = function(info) return KCL.db.profile.colorPaladin.r, KCL.db.profile.colorPaladin.g, KCL.db.profile.colorPaladin.b end,
							set = function(info, r,g,b) KCL.db.profile.colorPaladin.r = r; KCL.db.profile.colorPaladin.g = g; KCL.db.profile.colorPaladin.b = b; KCL_upvaluedOptionsHex() end,
						},
						colorPriest = {
							type = "color",
							order = 23,
							name = "|TInterface\\GLUES\\CHARACTERCREATE\\UI-CHARACTERCREATE-CLASSES:20:20:1:0:256:256:130:186:68:124|t  Priest",
							get = function(info) return KCL.db.profile.colorPriest.r, KCL.db.profile.colorPriest.g, KCL.db.profile.colorPriest.b end,
							set = function(info, r,g,b) KCL.db.profile.colorPriest.r = r; KCL.db.profile.colorPriest.g = g; KCL.db.profile.colorPriest.b = b; KCL_upvaluedOptionsHex() end,
						},
						colorRogue = {
							type = "color",
							order = 24,
							name = "|TInterface\\GLUES\\CHARACTERCREATE\\UI-CHARACTERCREATE-CLASSES:20:20:1:0:256:256:131:187:4:60|t  Rogue",
							get = function(info) return KCL.db.profile.colorRogue.r, KCL.db.profile.colorRogue.g, KCL.db.profile.colorRogue.b end,
							set = function(info, r,g,b) KCL.db.profile.colorRogue.r = r; KCL.db.profile.colorRogue.g = g; KCL.db.profile.colorRogue.b = b; KCL_upvaluedOptionsHex() end,
						},
						colorShaman = {
							type = "color",
							order = 25,
							name = "|TInterface\\GLUES\\CHARACTERCREATE\\UI-CHARACTERCREATE-CLASSES:20:20:1:0:256:256:68:124:68:124|t  Shaman",
							get = function(info) return KCL.db.profile.colorShaman.r, KCL.db.profile.colorShaman.g, KCL.db.profile.colorShaman.b end,
							set = function(info, r,g,b) KCL.db.profile.colorShaman.r = r; KCL.db.profile.colorShaman.g = g; KCL.db.profile.colorShaman.b = b; KCL_upvaluedOptionsHex() end,
						},
						colorWarlock = {
							type = "color",
							order = 26,
							name = "|TInterface\\GLUES\\CHARACTERCREATE\\UI-CHARACTERCREATE-CLASSES:20:20:1:0:256:256:194:250:68:124|t  Warlock",
							get = function(info) return KCL.db.profile.colorWarlock.r, KCL.db.profile.colorWarlock.g, KCL.db.profile.colorWarlock.b end,
							set = function(info, r,g,b) KCL.db.profile.colorWarlock.r = r; KCL.db.profile.colorWarlock.g = g; KCL.db.profile.colorWarlock.b = b; KCL_upvaluedOptionsHex() end,
						},
						colorWarrior = {
							type = "color",
							order = 27,
							name = "|TInterface\\GLUES\\CHARACTERCREATE\\UI-CHARACTERCREATE-CLASSES:20:20:1:0:256:256:4:60:4:60|t  Warrior",
							get = function(info) return KCL.db.profile.colorWarrior.r, KCL.db.profile.colorWarrior.g, KCL.db.profile.colorWarrior.b end,
							set = function(info, r,g,b) KCL.db.profile.colorWarrior.r = r; KCL.db.profile.colorWarrior.g = g; KCL.db.profile.colorWarrior.b = b; KCL_upvaluedOptionsHex() end,
						},
						description03 = {
							type = "description",
							order = 28,
							name = " ",
						},
						colorFriendlyReaction = {
							type = "color",
							order = 29,
							name = "|TInterface\\Icons\\Spell_ChargePositive:20:20:1:0:"..iconCropped.."|t  Friendly",
							get = function(info) return KCL.db.profile.colorFriendlyReaction.r, KCL.db.profile.colorFriendlyReaction.g, KCL.db.profile.colorFriendlyReaction.b end,
							set = function(info, r,g,b) KCL.db.profile.colorFriendlyReaction.r = r; KCL.db.profile.colorFriendlyReaction.g = g; KCL.db.profile.colorFriendlyReaction.b = b; KCL_upvaluedOptionsHex() end,
						},
						colorHostileReaction = {
							type = "color",
							order = 30,
							name = "|TInterface\\Icons\\Spell_ChargeNegative:20:20:1:0:"..iconCropped.."|t  Hostile",
							get = function(info) return KCL.db.profile.colorHostileReaction.r, KCL.db.profile.colorHostileReaction.g, KCL.db.profile.colorHostileReaction.b end,
							set = function(info, r,g,b) KCL.db.profile.colorHostileReaction.r = r; KCL.db.profile.colorHostileReaction.g = g; KCL.db.profile.colorHostileReaction.b = b; KCL_upvaluedOptionsHex() end,
						},
						colorUnknownReaction = {
							type = "color",
							order = 31,
							name = "|TInterface\\Icons\\INV_Misc_QuestionMark:20:20:1:0:"..iconCropped.."|t  Unknown",
							get = function(info) return KCL.db.profile.colorUnknownReaction.r, KCL.db.profile.colorUnknownReaction.g, KCL.db.profile.colorUnknownReaction.b end,
							set = function(info, r,g,b) KCL.db.profile.colorUnknownReaction.r = r; KCL.db.profile.colorUnknownReaction.g = g; KCL.db.profile.colorUnknownReaction.b = b; KCL_upvaluedOptionsHex() end,
						},
						description04 = {
							type = "description",
							order = 32,
							name = "\n",
						},
						executeResetcolor = {
							type = "execute",
							order = 33,
							descStyle = "",
							name = "|TInterface\\Icons\\INV_Misc_Rune_01:20:20:1:0:"..iconCropped.."|t |cffFFFFFFReset Colors|r",
							confirm = true, confirmText = "Reset Colors?  |TInterface\\Icons\\INV_Misc_QuestionMark:22:22:1:0:"..iconCropped.."|t",
							func = function()
							--	for some weird reason the defaults also get saved/changed with: KCL.db.profile.blaat = KCL.db.defaults.profile.blaat
							--	i coded something wrong i think, since it worked OK at some point; hardcoding it it in then..
								KCL.db.profile.colorTaunt = {r = 1, g = 0, b = 0}
								KCL.db.profile.colorInterrupt = {r = 0, g = 110/255, b = 1}
								KCL.db.profile.colorDispel = {r = 1, g = 1, b = 1}
								KCL.db.profile.colorReflect = {r = 1, g = 1, b = 1}
								KCL.db.profile.colorCrowdControl = {r = 1, g = 1, b = 1}
								KCL.db.profile.colorCC_Break = {r = 1, g = 1, b = 1}
								KCL.db.profile.colorDeath = {r = 1, g = 1, b = 1}
								KCL.db.profile.colorResurrection = {r = 175/255, g = 1, b = 47/255}
								KCL.db.profile.colorFriendlyReaction = {r = 0.34, g = 0.64, b = 1.00}
								KCL.db.profile.colorHostileReaction = {r = 0.75, g = 0.05, b = 0.05}
								KCL.db.profile.colorUnknownReaction = {r = 191/255, g = 191/255, b = 191/255}
								KCL.db.profile.colorPhysicalSpellSchool = {r = 1.00, g = 1.00, b = 0.00}
								KCL.db.profile.colorHolySpellSchool = {r = 1.00, g = 0.90, b = 0.50}
								KCL.db.profile.colorFireSpellSchool = {r = 1.00, g = 0.50, b = 0.00}
								KCL.db.profile.colorNatureSpellSchool = {r = 0.30, g = 1.00, b = 0.30}
								KCL.db.profile.colorFrostSpellSchool = {r = 0.50, g = 1.00, b = 1.00}
								KCL.db.profile.colorShadowSpellSchool = {r = 0.50, g = 0.50, b = 1.00}
								KCL.db.profile.colorArcaneSpellSchool = {r = 1.00, g = 0.50, b = 1.00}
								KCL.db.profile.colorDeathKnight = {r = 0.77, g = 0.12, b = 0.23}
								KCL.db.profile.colorDruid = {r = 1.00 , g = 0.49, b = 0.04}
								KCL.db.profile.colorHunter = {r = 0.67, g = 0.83, b = 0.45}
								KCL.db.profile.colorMage = {r = 0.41, g = 0.80, b = 0.94}
								KCL.db.profile.colorPaladin = {r = 0.96, g = 0.55, b = 0.73}
								KCL.db.profile.colorPriest = {r = 1.00, g = 1.00, b = 1.00}
								KCL.db.profile.colorRogue = {r = 1.00, g = 0.96, b = 0.41}
								KCL.db.profile.colorShaman = {r = 0.00, g = 0.44, b = 0.87}
								KCL.db.profile.colorWarlock = {r = 0.58, g = 0.51, b = 0.79}
								KCL.db.profile.colorWarrior = {r = 0.78, g = 0.61, b = 0.43}
								KCL.db.profile.colorFriendlyReaction = {r = 0.34, g = 0.64, b = 1.00}
								KCL.db.profile.colorHostileReaction = {r = 0.75, g = 0.05, b = 0.05}
								KCL.db.profile.colorUnknownReaction = {r = 191/255, g = 191/255, b = 191/255}
								KCL_upvaluedOptionsHex() -- update hex colors
							end,
						},
					},
				},
				groupIcon = {
					type = "group",
					order = 2,
					name = "|TInterface\\Icons\\Trade_Engineering:20:20:1:0:"..iconCropped.."|t  |cffFFFFFFIcons|r",
					args = {
						selectIconSize = {
							type = "select",
							order = 1,
							descStyle = "", 
							name = "Spell Icon |cffFFFFFFSize|r", --  {1 "Disabled", 12-32 size}
							values = {"|cffFF0000"..ADDON_DISABLED.."|r", nil, nil, nil, nil, nil, nil, nil, nil, nil, nil, "12", nil, "14", nil, "16 = |cffFBDB00Default|r", nil, "18",  nil, "20", nil, "22", nil, "24", nil, "26", nil, "28", nil, "30", nil, "32"},
							get = function(info) return KCL.db.profile.DB_iconSize end,
							set = function(info, value) KCL.db.profile.DB_iconSize = value; KCL_upvaluedOptions() end,
						},
						toggleCropIcon = {
							type = "toggle",
							order = 2,
							descStyle = "",
							name = "|TInterface\\Icons\\Trade_Engineering:26:26:1:0|t |TInterface\\Icons\\Trade_Engineering:24:24:1:0:64:64:4:60:4:60|t  |cffADFF2FCrop|r Spell Icon",
							get = function(info) return KCL.db.profile.DB_iconCropped end,
							set = function(info, value) KCL.db.profile.DB_iconCropped = value; KCL_upvaluedOptions() end,
							disabled = function() if KCL.db.profile.DB_iconSize == false or KCL.db.profile.enableAddOn == false then return true end; end,
						},
						header = {
							type = "header",
							order = 3,
							name = "",
						},
						toggleTimestamp = {
							type = "toggle",
							order = 4,
							desc = "Adds a timestamp to your messages",
							name = "Timestamp",
							get = function(info) return KCL.db.profile.optionsTimestamp end,
							set = function(info, value) KCL.db.profile.optionsTimestamp = value; optionsTimestamp = value; end,
						},
					},
				},
				groupFun = {
					type = "group",
					order = 3,
					name = "|TInterface\\AddOns\\Ketho_CombatLog\\Images\\Awesome:20:20:1:0|t  |cffF6ADC6Fun|r",
					args = {
						toggleFeast = {
							type = "toggle",
							order = 1,
							desc = "|cffF6ADC6\"om nom nom nom\"|r", 
							name = "  Feasts",
							get = function(info) return KCL.db.profile.Feast end,
							set = function(info, value) KCL.db.profile.Feast = value; KCL_upvaluedOptions() end,
						},
						descriptionFeasts = {
							type = "description",
							order = 2,
							name = "     |TInterface\\Icons\\Spell_Misc_Food:32:32:0:0:"..iconCropped.."|t    |TInterface\\Icons\\INV_Misc_Food_Meat_Cooked_02:32:32:0:0:"..iconCropped.."|t    |TInterface\\Icons\\INV_Misc_Food_99:32:32:0:0:"..iconCropped.."|t    |TInterface\\Icons\\INV_Misc_Fish_52:32:32:0:0:"..iconCropped.."|t    |TInterface\\Icons\\Ability_Hunter_Pet_Boar:32:32:0:0:"..iconCropped.."|t",
						},
						header01 = {
							type = "header",
							order = 3,
							name = "",
						},
						toggleRepairBot = {
							type = "toggle",
							order = 4,
							desc = "|cffF6ADC6\"oh god not another wipe\"|r", 
							name = "  Repair Bots",
							get = function(info) return KCL.db.profile.RepairBot end,
							set = function(info, value) KCL.db.profile.RepairBot = value; KCL_upvaluedOptions() end,
						},
						descriptionRepairBot = {
							type = "description",
							order = 5,
							name = "     |TInterface\\Minimap\\Tracking\\Repair:36:36:-2:0:"..iconCropped.."|t    |TInterface\\Icons\\inv_pet_lilsmoky:32:32:0:0:"..iconCropped.."|t    |TInterface\\Icons\\INV_Misc_EngGizmos_14:32:32:0:0:"..iconCropped.."|t    |TInterface\\Icons\\inv_misc_molle:32:32:0:0:"..iconCropped.."|t",
						},
						header02 = {
							type = "header",
							order = 6,
							name = "",
						},
						toggleFun = {
							type = "toggle",
							order = 7,
							desc = "|cffF6ADC6\"trolololol\"|r", 
							name = "  \"Fun\"",
							get = function(info) return KCL.db.profile.Fun end,
							set = function(info, value) KCL.db.profile.Fun = value; KCL_upvaluedOptions() end,
						},
						descriptionFun = {
							type = "description",
							order = 8,
							name = "     |TInterface\\AddOns\\Ketho_CombatLog\\Images\\Awesome:32:32:0:0|t    |TInterface\\Icons\\inv_misc_mohawkgrenade:32:32:0:0:"..iconCropped.."|t    |TInterface\\Icons\\INV_Misc_Toy_10:32:32:0:0:"..iconCropped.."|t    |TInterface\\Icons\\INV_Misc_Bag_28_Halloween:32:32:0:0:"..iconCropped.."|t    |TInterface\\Icons\\INV_Misc_Sandbox_Spectraltiger_01:32:32:0:0:"..iconCropped.."|t",
						},
						header03 = {
							type = "header",
							order = 9,
							name = "",
						},
					},
				},
				groupClassAbility = {
					type = "group",
					order = 4,
					name = "|TInterface\\Icons\\Ability_Rogue_TricksOftheTrade:20:20:1:0:"..iconCropped.."|t  |cffFFFFFFAbility|r",
					args = {
						toggleSoulstoneResurrection = {
							type = "toggle",
							order = 1,
							desc = "Stores the friendly target's soul.  If the target dies while his soul is stored, he will be able to resurrect with |cff71D5FF30%|r health and |cff71D5FF30%|r mana.", 
							name = "|TInterface\\Icons\\Spell_Shadow_SoulGem:24:24:1:0:"..iconCropped.."|t  |cff9482C9Soulstone Resurrection|r",
							get = function(info) return KCL.db.profile.abilitySoulstone end,
							set = function(info, value) KCL.db.profile.abilitySoulstone = value; KCL_upvaluedOptions() end,
						},
						toggleFocusMagic = {
							type = "toggle",
							order = 2,
							desc = "Increases the target's chance to critically hit with spells by |cff71D5FF3%|r for |cff71D5FF30 min|r.  When the target critically hits your chance to critically hit with spells is increased by |cff71D5FF3%|r for |cff71D5FF10 sec|r.  Cannot be cast on self.  Limit 1 target.", 
							name = "|TInterface\\Icons\\Spell_Arcane_StudentOfMagic:24:24:1:0:"..iconCropped.."|t  |cff69CCF0Focus Magic|r",
							get = function(info) return KCL.db.profile.abilityFocusMagic end,
							set = function(info, value) KCL.db.profile.abilityFocusMagic = value; KCL_upvaluedOptions() end,
						},
						toggleVigilance = {
							type = "toggle",
							order = 3,
							desc = "Focus your protective gaze on a group or raid target.  Each time they are hit by an attack your |cff71D5FFTaunt|r cooldown is refreshed and you gain |cff71D5FFVengeance|r as if |cff71D5FF20%|r of the damage was done to you.  Lasts |cff71D5FF30 min|r.  This effect can only be on one target at a time.", 
							name = "|TInterface\\Icons\\Ability_Warrior_Vigilance:24:24:1:0:"..iconCropped.."|t  |cffC79C6EVigilance|r",
							get = function(info) return KCL.db.profile.abilityVigilance end,
							set = function(info, value) KCL.db.profile.abilityVigilance = value; KCL_upvaluedOptions() end,
						},
						toggleMisdirection = {
							type = "toggle",
							order = 4,
							desc = "The current party or raid member targeted will receive the threat caused by your next damaging attack and all actions taken for |cff71D5FF4 sec|r afterwards.  Transferred threat is not permanent, and will fade after |cff71D5FF30 sec|r.", 
							name = "|TInterface\\Icons\\Ability_Hunter_Misdirection:24:24:1:0:"..iconCropped.."|t  |cffABD473Misdirection|r",
							get = function(info) return KCL.db.profile.abilityMisdirection end,
							set = function(info, value) KCL.db.profile.abilityMisdirection = value; KCL_upvaluedOptions() end,
						},
						toggleTricksTrade = {
							type = "toggle",
							order = 5,
							desc = "The threat caused by your next damaging attack and all actions taken for |cff71D5FF6 sec|r afterwards will be transferred to the target party or raid member, and all damage caused by the target is increased by |cff71D5FF15%|r during this time.  Transferred threat is not permanent, and will fade after |cff71D5FF30 sec|r.", 
							name = "|TInterface\\Icons\\Ability_Rogue_TricksOftheTrade:24:24:1:0:"..iconCropped.."|t  |cffFFF569Tricks of the Trade|r",
							get = function(info) return KCL.db.profile.abilityTricksTrade end,
							set = function(info, value) KCL.db.profile.abilityTricksTrade = value; KCL_upvaluedOptions() end,
						},
						toggleInnervate = {
							type = "toggle",
							order = 6,
							desc = "Causes the target to regenerate mana equal to |cff71D5FF20%|r of the casting |cffFF7D0ADruid's|r maximum mana pool over |cff71D5FF10 sec|r.", 
							name = "|TInterface\\Icons\\Spell_Nature_Lightning:24:24:1:0:"..iconCropped.."|t  |cffFF7D0AInnervate|r",
							get = function(info) return KCL.db.profile.abilityInnervate end,
							set = function(info, value) KCL.db.profile.abilityInnervate = value; KCL_upvaluedOptions() end,
						},
						toggleHeroismBloodlust = {
							type = "toggle",
							order = 7,
							desc = "Increases melee, ranged, and spell casting speed by |cff71D5FF30%|r for all party and raid members.  Lasts |cff71D5FF40 sec|r.", 
							name = "|TInterface\\Icons\\Ability_Shaman_Heroism:24:24:1:0:"..iconCropped.."|t |TInterface\\Icons\\Spell_Nature_BloodLust:24:24:1:0:"..iconCropped.."|t  |cff0070DEHeroism|r / |cff0070DEBloodlust|r",
							get = function(info) return KCL.db.profile.abilityHeroismBloodlust end,
							set = function(info, value) KCL.db.profile.abilityHeroismBloodlust = value; KCL_upvaluedOptions() end,
						},
						toggleRitualRefreshment = {
							type = "toggle",
							order = 8,
							desc = "Begins a ritual that creates a refreshment table.  Raid members can click the table to acquire Conjured mana food.  The tables lasts for |cff71D5FF3 min|r or |cff71D5FF50 charges|r.  Requires the caster and 2 additional party members to complete the ritual.  In order to participate, all players must right-click the refreshment portal and not move until the ritual is complete.", 
							name = "|TInterface\\Icons\\Spell_Arcane_MassDispel:24:24:1:0:"..iconCropped.."|t  |cff69CCF0Ritual of Refreshment|r",
							get = function(info) return KCL.db.profile.abilityRitualRefreshment end,
							set = function(info, value) KCL.db.profile.abilityRitualRefreshment = value; KCL_upvaluedOptions() end,
						},
						toggleMindVision = {
							type = "toggle",
							order = 9,
							desc = "Allows the caster to see through the target's eyes for |cff71D5FF1 min|r.  Will not work if the target is in another instance or on another continent.", 
							name = "|TInterface\\Icons\\Spell_Holy_MindVision:24:24:1:0:"..iconCropped.."|t  Mind Vision",
							get = function(info) return KCL.db.profile.abilityMindVision end,
							set = function(info, value) KCL.db.profile.abilityMindVision = value; KCL_upvaluedOptions() end,
						},
					},
				},
				groupAbout = {
					type = "group",
					order = 5,
					name = "|TInterface\\Icons\\INV_Misc_QuestionMark:20:20:1:0:"..iconCropped.."|t  |cffFFFFFFAbout|r",
					args = {
						header01 = {
							type = "header",
							order = 1,
							name = "|cffADFF2FKetho|r |cffFFFFFFCombatLog|r",
						},
						description01 = {
							type = "description",
							order = 2,
							name = ".. by |cffFFFFFFKetho|r @ |cffB6CA00EU-Boulderfist|r\n\n|cff87CEFAhttp://wow.|r|cffADFF2Fcurse|r|cff87CEFA.com/downloads/wow-addons/details/ketho-combat.aspx|r\n",
						},
						header02 = {
							type = "header",
							order = 3,
							name = "Changelog |cffB6CA00v0.90|r",
						},
						description02 = {
							type = "description",
							order = 4,
							name = "1) Completely rewrote and optimized code\n2) Updated to Ace3 r981 [2010.10.27]\n3) Renamed from |cff71D5FFKetho Combat|r to |cffADFF2FKetho CombatLog|r\n",
						},
						header03 = {
							type = "header",
							order = 5,
							name = "To Do",
						},
						description03 = {
							type = "description",
							order = 6,
							name = "1) Locales\n2) Player \"vehicle\" deaths\n",
						},
						header04 = {
							type = "header",
							order = 7,
							name = "Known Bugs",
						},
						description04 = {
							type = "description",
							order = 8,
							name = "1) Rarely shows |cff71D5FF\"false positive Deaths\"|r\n2) |cff71D5FFDuel Losses|r show as deaths",
						},
						description05 = {
							type = "description",
							order = 9,
							name = function() local a; if englishPlayerFaction == "Alliance" then a = "War3_MountainKing" elseif englishPlayerFaction == "Horde" then a = "War3_Blademaster" end
								return "|TInterface\\AddOns\\Ketho_CombatLog\\Images\\"..a..":64:64:2:-68|t" end,
						},
					},
				},
			},
		},
		optionsProfiles = { -- how to not show Profiles in a "group"? it always shows in a tree/select/tab group .. if you get what i mean.. lol im randomly talking to ppl in my comments ><
			type = "group",
			name = "",
			args = {
				profiles = {
					type = "group",
					name = "",
					inline = true,
					args = {
						profiles = {
							type = "group",
							name = "",
						},
					},
				},
			},
		},
	},
}

--- Blizzard GUI Defaults ---
local defaults = {
	profile = {
		enableAddOn = true,
		Taunt = true,
		Death = true,
		combatPvE = true,

		colorTaunt = {r = 1, g = 0, b = 0}, -- #FF0000
		colorInterrupt = {r = 0, g = 110/255, b = 1}, -- #006EFF
		colorDispel = {r = 1, g = 1, b = 1},
		colorReflect = {r = 1, g = 1, b = 1},
		colorDeath = {r = 1, g = 1, b = 1},
		colorResurrection = {r = 175/255, g = 1, b = 47/255}, -- #ADFF2F (GreenYellow)
		colorCrowdControl = {r = 1, g = 1, b = 1},
		colorCC_Break = {r = 1, g = 1, b = 1},
	--	http://www.wowpedia.org/API_COMBAT_LOG_EVENT#Spell_School
		colorPhysicalSpellSchool = {r = 1.00, g = 1.00, b = 0.00}, -- #FFFF00
		colorHolySpellSchool = {r = 1.00, g = 0.90, b = 0.50}, -- #FFE680
		colorFireSpellSchool = {r = 1.00, g = 0.50, b = 0.00}, -- #FF8000
		colorNatureSpellSchool = {r = 0.30, g = 1.00, b = 0.30}, -- #4DFF4D
		colorFrostSpellSchool = {r = 0.50, g = 1.00, b = 1.00}, -- #80FFFF
		colorShadowSpellSchool = {r = 0.50, g = 0.50, b = 1.00}, -- #8080FF
		colorArcaneSpellSchool = {r = 1.00, g = 0.50, b = 1.00}, -- #FF80FF
	--	http://www.wowpedia.org/Class_colors
		colorDeathKnight = {r = 0.77, g = 0.12, b = 0.23}, -- #C41F3B
		colorDruid = {r = 1.00 , g = 0.49, b = 0.04}, -- #FF7D0A
		colorHunter = {r = 0.67, g = 0.83, b = 0.45}, -- #ABD473
		colorMage = {r = 0.41, g = 0.80, b = 0.94}, -- #69CCF0
		colorPaladin = {r = 0.96, g = 0.55, b = 0.73}, -- #F58CBA
		colorPriest = {r = 1.00, g = 1.00, b = 1.00}, -- #FFFFFF
		colorRogue = {r = 1.00, g = 0.96, b = 0.41}, -- #FFF569
		colorShaman = {r = 0.00, g = 0.44, b = 0.87}, -- #0070DE
		colorWarlock = {r = 0.58, g = 0.51, b = 0.79}, -- #9482C9
		colorWarrior = {r = 0.78, g = 0.61, b = 0.43}, -- #C79C6E
		colorFriendlyReaction = {r = 0.34, g = 0.64, b = 1.00}, -- #57A3FF ..\Interface\AddOns\Blizzard_CombatLog\Blizzard_CombatLog.lua >> COMBATLOG_DEFAULT_COLORS.unitColoring["COMBATLOG_FILTER_FRIENDLY_UNITS"]
		colorHostileReaction = {r = 0.75, g = 0.05, b = 0.05}, -- #BF0D0D
		colorUnknownReaction = {r = 191/255, g = 191/255, b = 191/255}, -- #BFBFBF

		DB_iconSize = 16,
		DB_iconCropped = true,
	},
	char = {
		chatFrame = 2, -- ChatFrame1
		chatChannel = 1, -- Disabled
	},
}

	--------------------------------------------------
	-----  03 OnInitialize, OnEnable, OnDisable  ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- 
	--------------------------------------------------
function KCL:OnInitialize() -- Called when the addon is loaded
--	Creates a new database object that can be used to handle database settings and profiles -- http://www.wowace.com/addons/ace3/pages/api/ace-db-3-0/
	self.db = LibStub("AceDB-3.0"):New("KethoCombatLogDB", defaults, true) -- KethoCombatLog.db
	
--	Register an options table with the config registry -- http://www.wowace.com/addons/ace3/pages/api/ace-config-registry-3-0/
	local ACR = LibStub("AceConfigRegistry-3.0")
	ACR:RegisterOptionsTable("KCL_optionsMain", options.args.optionsMain)
	ACR:RegisterOptionsTable("KCL_optionsCombatEvent", options.args.optionsAdvanced) -- LibStub("AceConfigRegistry-3.0"):RegisterOptionsTable("appCombatEvent", optionsCombatEvent)
	ACR:RegisterOptionsTable("KCL_optionsProfiles", options.args.optionsProfiles)
	
--	Add an option table into the Blizzard Interface Options panel -- http://www.wowace.com/addons/ace3/pages/api/ace-config-dialog-3-0/	
	local ACD = LibStub("AceConfigDialog-3.0"); local optionsMainName = "Ketho |cffFFFFFFCombatLog|r|TInterface\\Icons\\INV_Sword_01:20:20:8:0:"..iconCropped.."|t"
	self.optionsFrame = ACD:AddToBlizOptions("KCL_optionsMain", optionsMainName) -- "self.optionsFrame" used for "InterfaceOptionsFrame_OpenToCategory"
	ACD:AddToBlizOptions("KCL_optionsCombatEvent", "|TInterface\\Icons\\Trade_Engineering:24:24:1:0:"..iconCropped.."|t  Advanced", optionsMainName)
	ACD:AddToBlizOptions("KCL_optionsProfiles", "|TInterface\\Icons\\INV_Misc_Note_01:24:24:1:0:"..iconCropped.."|t  Profiles", optionsMainName)

--	Get/Create a option table that you can use in your addon to control the profiles of AceDB-3.0 -- http://www.wowace.com/addons/ace3/pages/api/ace-dboptions-3-0/
	options.args.optionsProfiles.args.profiles.args.profiles = LibStub("AceDBOptions-3.0"):GetOptionsTable(self.db) -- STILL dont understand how it works with the "groups" and stuff

--	Register chat commands -- http://www.wowace.com/addons/ace3/pages/api/ace-console-3-0/
	self:RegisterChatCommand("ket", "slashCommand")
	self:RegisterChatCommand("kcl", "slashCommand")
	self:RegisterChatCommand("ketho", "slashCommand")
	self:RegisterChatCommand("kethocombat", "slashCommand")
	self:RegisterChatCommand("kethocombatlog", "slashCommand")
	
--	Initialize upvalued stuff from the AceDB / AddOn API
	if self.db.char.chatFrame > 1 then CF = _G["ChatFrame"..self.db.char.chatFrame-1] end
	KCL_upvaluedOptions(); KCL_upvaluedOptionsHex() -- update upvalued options
	playerColor = KCL_UnitLinkClass("player", nil, playerClass) -- this must be called after KCL_upvaluedOptions(), since hexColors arent initialized before it

	if optionsDebug == true then self:Print("Initialized (|cff71D5FFOnInitialize|r)") end
	if self.db.profile.enableAddOn == false then self:Disable() -- Turn AddOn off again
		if optionsDebug == true then self:Print("|cffFF2424Disabled|r (|cff71D5FFOnInitialize|r)") end
	end
end

function KCL:OnEnable() -- Called when the addon is enabled	
--	Subscribe to Events
	self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
	if optionsDebug == true then self:Print("|cffB6CA00Enabled|r (|cff71D5FFOnEnable|r)") end
end

function KCL:OnDisable() -- Called when the addon is disabled
	self:UnregisterAllEvents() -- Unsubscribe from all Events
	if optionsDebug == true then self:Print("|cffFF2424Disabled|r (|cff71D5FFOnDisable|r)") end
end

	-----------------------------------
	-----  04  CALLBACK HANDLERS  ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- 
	-----------------------------------
function KCL:OptionsDisabled() -- Disables(gray out) options when AddOn disabled
	if self.db.profile.enableAddOn == false then return true end
end

-- upvalue instead of table checkups for frequently fired events like CLEU; exceeded the 60 upvalues limit here, had to split up in 2 functions
function KCL_upvaluedOptions(info)
	local db = KCL.db.profile -- 1 table lookup instead of 3
	optionsTaunt = db.Taunt
	optionsInterrupt = db.Interrupt
	optionsDispel = db.Dispel
	optionsReflect = db.Reflect
	optionsDeath = db.Death
	optionsResurrection = db.Resurrection
	optionsCrowdControl = db.CrowdControl
	optionsCC_Break = db.CC_Break
	optionsTankTaunt = db.tankTaunt
	optionsTankBreaksCC = db.tankBreaksCC
	optionsPetGrowl = db.petGrowl
	combatPvE = db.combatPvE
	combatPvP = db.combatPvP
	combatWorld = db.combatWorld
	optionsChatFrame = KCL.db.char.chatFrame
	optionsChatChannel = KCL.db.char.chatChannel
	optionsIconSize = db.DB_iconSize
	optionsIconCropped = db.DB_iconCropped
	if optionsIconCropped == false then iconCropped = "" else iconCropped = "64:64:4:60:4:60" end
	optionsTimestamp = db.optionsTimestamp
	optionsDebug = db.Debug
	optionsFeast = db.Feast
	optionsRepairBot = db.RepairBot
	optionsFun = db.Fun
	optionsInnervate = db.abilityInnervate
	optionsMisdirection = db.abilityMisdirection
	optionsFocusMagic = db.abilityFocusMagic
	optionsTricksTrade = db.abilityTricksTrade
	optionsSoulstoneResurrection = db.abilitySoulstone
	optionsVigilance = db.abilityVigilance
	optionsBloodlust = db.abilityHeroismBloodlust
	optionsRitualRefreshment = db.abilityRitualRefreshment
	optionsMindVision = db.abilityMindVision
end

function KCL_upvaluedOptionsHex(info)
	local db = KCL.db.profile
	hexTaunt = KCL_Dec2Hex(db.colorTaunt.r, db.colorTaunt.g, db.colorTaunt.b)
	hexInterrupt = KCL_Dec2Hex(db.colorInterrupt.r, db.colorInterrupt.g, db.colorInterrupt.b)
	hexReflect = KCL_Dec2Hex(db.colorReflect.r, db.colorReflect.g, db.colorReflect.b)
	hexDispel = KCL_Dec2Hex(db.colorDispel.r, db.colorDispel.g, db.colorDispel.b)
	hexCrowdControl = KCL_Dec2Hex(db.colorCrowdControl.r, db.colorCrowdControl.g, db.colorCrowdControl.b)
	hexCC_Break = KCL_Dec2Hex(db.colorCC_Break.r, db.colorCC_Break.g, db.colorCC_Break.b)
	hexDeath = KCL_Dec2Hex(db.colorDeath.r, db.colorDeath.g, db.colorDeath.b)
	hexResurrection = KCL_Dec2Hex(db.colorResurrection.r, db.colorResurrection.g, db.colorResurrection.b)
	hexPhysical = KCL_Dec2Hex(db.colorPhysicalSpellSchool.r, db.colorPhysicalSpellSchool.g, db.colorPhysicalSpellSchool.b)
	hexHoly = KCL_Dec2Hex(db.colorHolySpellSchool.r, db.colorHolySpellSchool.g, db.colorHolySpellSchool.b)
	hexFire = KCL_Dec2Hex(db.colorFireSpellSchool.r, db.colorFireSpellSchool.g, db.colorFireSpellSchool.b)
	hexNature = KCL_Dec2Hex(db.colorNatureSpellSchool.r, db.colorNatureSpellSchool.g, db.colorNatureSpellSchool.b)
	hexFrost = KCL_Dec2Hex(db.colorFrostSpellSchool.r, db.colorFrostSpellSchool.g, db.colorFrostSpellSchool.b)
	hexShadow = KCL_Dec2Hex(db.colorShadowSpellSchool.r, db.colorShadowSpellSchool.g, db.colorShadowSpellSchool.b)
	hexArcane = KCL_Dec2Hex(db.colorArcaneSpellSchool.r, db.colorArcaneSpellSchool.g, db.colorArcaneSpellSchool.b)
	hexDeathKnight = KCL_Dec2Hex(db.colorDeathKnight.r, db.colorDeathKnight.g, db.colorDeathKnight.b)
	hexDruid = KCL_Dec2Hex(db.colorDruid.r, db.colorDruid.g, db.colorDruid.b)
	hexHunter = KCL_Dec2Hex(db.colorHunter.r, db.colorHunter.g, db.colorHunter.b)
	hexMage = KCL_Dec2Hex(db.colorMage.r, db.colorMage.g, db.colorMage.b)
	hexPaladin = KCL_Dec2Hex(db.colorPaladin.r, db.colorPaladin.g, db.colorPaladin.b)
	hexPriest = KCL_Dec2Hex(db.colorPriest.r, db.colorPriest.g, db.colorPriest.b)
	hexRogue = KCL_Dec2Hex(db.colorRogue.r, db.colorRogue.g, db.colorRogue.b)
	hexShaman = KCL_Dec2Hex(db.colorShaman.r, db.colorShaman.g, db.colorShaman.b)
	hexWarlock = KCL_Dec2Hex(db.colorWarlock.r, db.colorWarlock.g, db.colorWarlock.b)
	hexWarrior = KCL_Dec2Hex(db.colorWarrior.r, db.colorWarrior.g, db.colorWarrior.b)
	hexFriendlyReaction = KCL_Dec2Hex(db.colorFriendlyReaction.r, db.colorFriendlyReaction.g, db.colorFriendlyReaction.b)
	hexHostileReaction = KCL_Dec2Hex(db.colorHostileReaction.r, db.colorHostileReaction.g, db.colorHostileReaction.b)
	hexUnknownReaction = KCL_Dec2Hex(db.colorUnknownReaction.r, db.colorUnknownReaction.g, db.colorUnknownReaction.b)
end

function KCL:slashCommand(input) -- Process the slash command ('input' contains whatever follows the slash command)
	if not input or input:trim() == "" then InterfaceOptionsFrame_OpenToCategory(self.optionsFrame)
	elseif input == "on" then if self.db.profile.enableAddOn == false then self:Enable(); self.db.profile.enableAddOn = true; self:Print("|cffB6CA00Enabled|r"); LibStub("AceConfigRegistry-3.0"):NotifyChange("KCL_optionsMain") end
	elseif input == "off" then if self.db.profile.enableAddOn == true then self:Disable(); self.db.profile.enableAddOn = false; self:Print("|cffFF2424Disabled|r"); LibStub("AceConfigRegistry-3.0"):NotifyChange("KCL_optionsMain") end
	elseif input == "silence" then -- AceTimer here is only for feedback purpose
		if timeSilence == 0 then self:Print("Silenced: 1 Minute")
		else self:Print("Refreshed Silence: 1 Minute"); self:CancelTimer(self.silenceTimer, true) end
		timeSilence = GetTime() + 60; self.silenceTimer = self:ScheduleTimer(function() timeSilence = 0; self:Print("Unsilenced") end, 60)
	elseif input == "unsilence" then
	if timeSilence > 0 then self:Print("Unsilenced")
	else self:Print("Already Unsilenced") end
	timeSilence = 0; self:CancelTimer(self.silenceTimer, true) -- check if it silently fails if no AceTimer handle
	elseif input == "debug" then if optionsDebug == false then optionsDebug = true; self.db.profile.Debug = true; self:Print("Debug: |cffB6CA00On|r") else optionsDebug = false; self.db.profile.Debug = false; self:Print("Debug: |cffFF2424Off|r") end
	else local a, b, c = "|cff2E9AFE", "|cffB6CA00", "|cffFF2424"; print(a.."/ket|r: Opens Options\n"..a.."/ket|r "..b.."on|r: Turns AddOn on\n"..a.."/ket|r "..c.."off|r: Turns AddOn off\n"..a.."/ket|r "..c.."silence|r: Stops announce for |cff71D5FF60 sec.|r\n"..a.."/ket|r "..b.."un|r"..c.."silence|r: Resumes announce\n"..a.."/ket|r |cff71D5FFdebug|r: Toggles debug mode")
	end
end

function KCL_Dec2Hex(R, G, B) -- Convert: Decimal (0-255) -> Hexadecimal -- http://www.wowpedia.org/RGBToHex
	return string.format("%02X%02X%02X", R*255, G*255, B*255)
end

-- Class Color, Unit Link
function KCL_UnitLinkClass(info, unitID, unitClass, unitGUID, sourceName, destName) -- http://www.wowpedia.org/Class_colors
	local classColor; local classIcon; local a
	if	   unitClass == "DEATHKNIGHT" then classColor = hexDeathKnight
	elseif unitClass == "DRUID"		  then classColor = hexDruid
	elseif unitClass == "HUNTER"	  then classColor = hexHunter
	elseif unitClass == "MAGE"		  then classColor = hexMage
	elseif unitClass == "PALADIN"	  then classColor = hexPaladin
	elseif unitClass == "PRIEST"	  then classColor = hexPriest
	elseif unitClass == "ROGUE"		  then classColor = hexRogue
	elseif unitClass == "SHAMAN"	  then classColor = hexShaman
	elseif unitClass == "WARLOCK"	  then classColor = hexWarlock
	elseif unitClass == "WARRIOR"	  then classColor = hexWarrior
	end
	if unitID == "group" and destName then a = UnitName(destName)
	elseif unitID == "group" and not destName then a = UnitName(sourceName)
	elseif unitID == "target" then a = UnitName("target")
	end
	if info == "source" then
		return a, "|cff"..classColor.."|Hunit:"..unitGUID..":"..a.."|h["..a.."]|h|r"
	elseif info == "dest" then local b
		if destName == sourceName then b = QUICKBUTTON_NAME_SELF; else b = a end
		return a, "|cff"..classColor.."|Hunit:"..unitGUID..":"..a.."|h["..b.."]|h|r"
	elseif info == "player" then
		return classColor
	end
end

-- Spell School (Colored), Extra Spell School (Colored)
function KCL_spellSchool(value)
	local a; local b
	if	   value == 0x1  then a = STRING_SCHOOL_PHYSICAL; b = hexPhysical
	elseif value == 0x2  then a = STRING_SCHOOL_HOLY;	  b = hexHoly
	elseif value == 0x4  then a = STRING_SCHOOL_FIRE;	  b = hexFire
	elseif value == 0x8  then a = STRING_SCHOOL_NATURE;	  b = hexNature
	elseif value == 0x10 then a = STRING_SCHOOL_FROST;	  b = hexFrost
	elseif value == 0x20 then a = STRING_SCHOOL_SHADOW;	  b = hexShadow
	elseif value == 0x40 then a = STRING_SCHOOL_ARCANE;	  b = hexArcane
--	Double schools
	elseif value == 0x3  then a = STRING_SCHOOL_HOLYSTRIKE
	elseif value == 0x5  then a = STRING_SCHOOL_FLAMESTRIKE
	elseif value == 0x6  then a = STRING_SCHOOL_HOLYFIRE
	elseif value == 0x9  then a = STRING_SCHOOL_STORMSTRIKE
	elseif value == 0xA  then a = STRING_SCHOOL_HOLYSTORM
	elseif value == 0xC  then a = STRING_SCHOOL_FIRESTORM
	elseif value == 0x11 then a = STRING_SCHOOL_FROSTSTRIKE
	elseif value == 0x12 then a = STRING_SCHOOL_HOLYFROST
	elseif value == 0x14 then a = STRING_SCHOOL_FROSTFIRE
	elseif value == 0x18 then a = STRING_SCHOOL_FROSTSTORM
	elseif value == 0x21 then a = STRING_SCHOOL_SHADOWSTRIKE
	elseif value == 0x22 then a = STRING_SCHOOL_SHADOWLIGHT
	elseif value == 0x24 then a = STRING_SCHOOL_SHADOWFLAME
	elseif value == 0x28 then a = STRING_SCHOOL_SHADOWSTORM
	elseif value == 0x30 then a = STRING_SCHOOL_SHADOWFROST
	elseif value == 0x41 then a = STRING_SCHOOL_SPELLSTRIKE
	elseif value == 0x42 then a = STRING_SCHOOL_DIVINE
	elseif value == 0x44 then a = STRING_SCHOOL_SPELLFIRE			
	elseif value == 0x48 then a = STRING_SCHOOL_SPELLSTORM
	elseif value == 0x50 then a = STRING_SCHOOL_SPELLFROST
	elseif value == 0x60 then a = STRING_SCHOOL_SPELLSHADOW
--	Three or more schools
	elseif value == 0x1C then a = STRING_SCHOOL_ELEMENTAL
	elseif value == 0x7C then a = STRING_SCHOOL_CHROMATIC
	elseif value == 0x7E then a = STRING_SCHOOL_MAGIC
	elseif value == 0x7F then a = STRING_SCHOOL_CHAOS
	else a = STRING_SCHOOL_UNKNOWN.." ("..value..")"
	end
	if not b then b = "71D5FF" end
	return a, b, "|cff"..b..a.."|r" -- school(Name)(Color), extraSchool(Name)(Color)
end

-- Unit Reaction (Colored), Raid Target Icon
function KCL_UnitFlags(info, Flags)
	if info == "reaction" then
		if band(Flags, COMBATLOG_OBJECT_REACTION_FRIENDLY) > 0 then return hexFriendlyReaction -- Friendly Reaction Color
		elseif band(Flags, COMBATLOG_OBJECT_REACTION_HOSTILE) > 0 then return hexHostileReaction -- Hostile Reaction Color
		else return hexUnknownReaction -- Unknown Reaction Color
		end
	elseif info == "raidtarget" then
		local a = ""; local b = ""
		for i = 1, 8 do
			if band(Flags, _G["COMBATLOG_OBJECT_RAIDTARGET"..i]) > 0 then -- .. does this defeat the purpose of upvalues?
				a = "|TInterface\\TargetingFrame\\UI-RaidTargetingIcon_"..i..":"..optionsIconSize.."|t" -- Raid Target Icon (only works in party/raid so not when player is alone)
				b = "{rt"..i.."}"
			end
		end
		return a, b
	end
end

	--------------------------------
	-----  05  EVENT HANDLERS  ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- -----  ----- 
	--------------------------------
function KCL:COMBAT_LOG_EVENT_UNFILTERED(CLEU, ...)
	local timestamp, event, sourceGUID, sourceName, sourceFlags, destGUID, destName, destFlags, spellID, spellName, spellSchool, SuffixParam1, SuffixParam2, SuffixParam3, SuffixParam4, _, SuffixParam6, SuffixParam7, _, SuffixParam9 = ...

	local KCL_Time = GetTime()
--	Refresh instanceType & announceType every 10 sec
	if KCL_Time > cd_instanceType then
		cd_instanceType = KCL_Time + 10; _, instanceType = IsInInstance()
		if instanceType == "party" or instanceType == "arena" then announceType = "PARTY"
		elseif instanceType == "raid" then announceType = "RAID"
		end
	 end
--	InstanceType check (so the "workload" is optionally)
	if ((instanceType == "party" or instanceType == "raid") and combatPvE == true) or
	   ((instanceType == "pvp" or instanceType == "arena")	and combatPvP == true) or
		(instanceType == "none"								and combatWorld == true) then

	---- Initialization ----
	--	Unit Type, Unit Reaction Coloring -- http://www.wowpedia.org/API_UnitGUID
		local sourceType = tonumber(strsub(sourceGUID, 5, 5)) -- 5th digit, string converted to number (decimal)
		local destType = tonumber(strsub(destGUID, 5, 5))
		local sourceLink; local destLink
		local sourceReaction = KCL_UnitFlags("reaction", sourceFlags) -- http://www.wowpedia.org/UnitFlag
		local destReaction = KCL_UnitFlags("reaction", destFlags)
		local sourceRT, sourceRT2 = KCL_UnitFlags("raidtarget", sourceFlags) 
		local destRT, destRT2 = KCL_UnitFlags("raidtarget", destFlags) 
		local schoolName, schoolColor, schoolNameColor
		local extraSchoolName, extraSchoolColor, extraSchoolNameColor
		local spellIcon; local extraSpellIcon
		
		local isTank = (UnitGroupRolesAssigned(sourceName) == "TANK")
		local datestamp1, datestamp2 if optionsTimestamp == true then datestamp2 = date("[%H:%M:%S] "); datestamp1 = "|cffA9A9A9"..datestamp2.."|r" else datestamp1 = ""; datestamp2 = "" end
		local sourceName2, destName2, destNameSelf -- call UnitName whenever possible to remove (cross)realm names
		local a, b, q, r -- function-local scope, dynamic [upvalues / external local variables]; managed to exceed the 60 upvalues limit because I was creating new block-local variables for every SendChatMessage block ><
		if SuffixParam7 then SuffixParam7 = " "..TEXT_MODE_A_STRING_RESULT_CRITICAL else SuffixParam7 = "" end -- critical; reuse local variable instead of making new local variable
		if SuffixParam9 then SuffixParam9 = " "..TEXT_MODE_A_STRING_RESULT_CRUSHING else SuffixParam9 = "" end -- crushing
		if optionsChatChannel == 2 then q = announceType else q = "CHANNEL"; r = optionsChatChannel-2 end

	--	Unit Link -- http://www.wowpedia.org/UI_escape_sequences
		if sourceName then
			if sourceName == playerName then sourceLink = "|cff"..playerColor.."|Hunit:"..sourceGUID..":"..sourceName.."|h["..YOU.."]|h|r" -- You
			elseif UnitInParty(sourceName) or UnitInRaid(sourceName) then sourceName2, sourceLink = KCL_UnitLinkClass("source", "group", select(2,UnitClass(sourceName)), sourceGUID, sourceName) -- Party/Raid Class Color
			elseif sourceType == 0 and sourceName == UnitName("target") then sourceName2, sourceLink = KCL_UnitLinkClass("source", "target", select(2,UnitClass("target")), sourceGUID, sourceName) -- Target Class Color
			else sourceLink = "|cff"..sourceReaction.."|Hunit:"..sourceGUID..":"..sourceName.."|h["..sourceName.."]|h|r"
			end
			if not sourceName2 then sourceName2 = sourceName end -- fall back to sourceName if unit not in party/raid (for cutting out cross-realm names)
		end
		if destName then
			if destName == playerName then
				if destName == sourceName then a = QUICKBUTTON_NAME_SELF else a = YOU end
				destLink = "|cff"..playerColor.."|Hunit:"..destGUID..":"..destName.."|h["..a.."]|h|r"
			elseif UnitInParty(destName) or UnitInRaid(destName) then destName2, destLink = KCL_UnitLinkClass("dest", "group", select(2,UnitClass(destName)), destGUID, sourceName, destName)
			elseif destType == 0 and destName == UnitName("target") then destName2, destLink = KCL_UnitLinkClass("dest", "target", select(2,UnitClass("target")), destGUID, sourceName, destName)
			else
				if destName == sourceName then a = QUICKBUTTON_NAME_SELF else a = destName end
				destLink = "|cff"..destReaction.."|Hunit:"..destGUID..":"..destName.."|h["..a.."]|h|r"
			end
			if destName == sourceName then destName2 = QUICKBUTTON_NAME_SELF end
			if not destName2 then destName2 = destName end
		end

		if event ~= "SWING_DAMAGE" and event ~= "SWING_MISSED" and event ~= "UNIT_DIED" and event ~= "PARTY_KILL" and event ~= "UNIT_DESTROYED" and event ~= "UNIT_DISSIPATES" then
		--	Spell School (Colored)
			if spellSchool then schoolName, schoolColor, schoolNameColor = KCL_spellSchool(spellSchool) end
		--	Spell Link + Colored
			spellLink = "|cff71d5ff|Hspell:"..spellID.."|h["..spellName.."]|h|r"
			spellLinkColor = "|cff"..schoolColor.."|Hspell:"..spellID.."|h["..spellName.."]|h|r"
		--	Spell Icon
			if select(3, GetSpellInfo(spellID)) and optionsIconSize > 1 then
				spellIcon = "|T"..select(3,GetSpellInfo(spellID))..":"..optionsIconSize..":"..optionsIconSize..":1:0:"..iconCropped.."|t"
			else spellIcon = ""
			end
			if event == "SPELL_INTERRUPT" or event == "SPELL_DISPEL" or event == "SPELL_DISPEL_FAILED" or event == "SPELL_STOLEN" or event == "SPELL_AURA_BROKEN_SPELL" then
				if SuffixParam3 then extraSchoolName, extraSchoolColor, extraSchoolNameColor = KCL_spellSchool(SuffixParam3) end
				extraSpellLink = "|cff71d5ff|Hspell:"..SuffixParam1.."|h["..SuffixParam2.."]|h|r"
				extraSpellLinkColor = "|cff"..extraSchoolColor.."|Hspell:"..SuffixParam1.."|h["..SuffixParam2.."]|h|r"
				if select(3, GetSpellInfo(SuffixParam1)) and optionsIconSize > 1 then
					extraSpellIcon = "|T"..select(3,GetSpellInfo(SuffixParam1))..":"..optionsIconSize..":"..optionsIconSize..":1:0:"..iconCropped.."|t"
				else extraSpellIcon = ""
				end
			end
		end
	---- Combat Events ----
	--	Deaths
		if optionsDeath == true and destType == 0 and (KCL_Time > cd_Death or destName ~= lastDeath) then cd_Death = KCL_Time + 1 -- make sure dont show more than 1 killing blow on same person
			if (event == "SPELL_DAMAGE" or event == "SPELL_PERIODIC_DAMAGE" or event == "RANGE_DAMAGE") and SuffixParam2 > 0 then
				lastDeath = destName
				if sourceName then a = sourceLink else a = "" end -- no sourceName
				if destName == playerName then b = " ("..SuffixParam2.." "..L["Overkill"]..")" else b = "" end -- show overkill if the player died
				if destName == sourceName then -- suicide
					if optionsChatFrame>1 then CF:AddMessage(datestamp1..sourceRT..a.." |cff"..hexDeath.."suicided|r "..spellLinkColor..spellIcon.." "..SuffixParam1.." "..schoolNameColor..b..SuffixParam7..SuffixParam9) end
					if optionsChatChannel>1 and KCL_Time>timeSilence then SCM(datestamp2..sourceRT2.."["..sourceName2.."] "..ACTION_UNIT_DIED.." "..destRT2.."["..destName2.."]"..spellLink.." "..SuffixParam1.." "..schoolName..SuffixParam7..SuffixParam9, q, nil, r) end
				else
					if optionsChatFrame>1 then CF:AddMessage(datestamp1..destRT..destLink.." |cff"..hexDeath..ACTION_UNIT_DIED.."|r "..sourceRT..a..spellLinkColor..spellIcon.." "..SuffixParam1.." "..schoolNameColor..b..SuffixParam7..SuffixParam9) end
					if optionsChatChannel>1 and KCL_Time>timeSilence then SCM(datestamp2..destRT2.."["..destName2.."] "..ACTION_UNIT_DIED.." "..sourceRT2.."["..sourceName2.."]"..spellLink.." "..SuffixParam1.." "..schoolName..SuffixParam7..SuffixParam9, q, nil, r) end
				end
		--	"SWING_DAMAGE" event uses a different args system (spellID, spellName, spellSchool are "skipped")
			elseif event == "SWING_DAMAGE" and spellName > 0 then
				lastDeath = destName
				if SuffixParam4 then SuffixParam4 = " "..TEXT_MODE_A_STRING_RESULT_CRITICAL else SuffixParam4 = "" end -- critical; reuse local variable instead of making new local variable
				if SuffixParam6 then SuffixParam6 = " "..TEXT_MODE_A_STRING_RESULT_CRUSHING else SuffixParam6 = "" end -- crushing
				if destName == playerName then b = " ("..spellName.." "..L["Overkill"]..")" else b = "" end
				if optionsChatFrame>1 then CF:AddMessage(datestamp1..destRT..destLink.." |cff"..hexDeath..ACTION_UNIT_DIED.."|r "..sourceRT..sourceLink.." "..spellID.." |cff"..hexPhysical..MELEE.."|r"..b..SuffixParam7..SuffixParam9) end
				if optionsChatChannel>1 and KCL_Time>timeSilence then SCM(datestamp2..destRT2.."["..destName2.."] "..ACTION_UNIT_DIED.." "..sourceRT2.."["..sourceName2.."] "..spellID.." "..MELEE..SuffixParam7..SuffixParam9, q, nil, r) end
		--	Death Prevents
			elseif event == "SPELL_HEAL" and (spellID == 48153 or spellID == 66235) then -- Priest [Guardian Spirit]48153(SPELL_HEAL) Paladin [Ardent Defender] 66235(SPELL_HEAL)
				if optionsChatFrame>1 then CF:AddMessage(datestamp1..sourceRT..sourceLink..spellLinkColor.." |cff"..hexResurrection.."prevented death|r "..destRT..destLink.." "..SuffixParam1.." "..schoolNameColor) end
				if optionsChatChannel>1 and KCL_Time>timeSilence then SCM(datestamp2..sourceRT2.."["..sourceName2.."]"..spellLink.." prevented death "..destRT2.."["..destName2.."]"..spellLink.." "..SuffixParam1.." "..schoolName, q, nil, r) end
		--	Instagibs
			elseif event == "SPELL_INSTAKILL" then
				if optionsChatFrame>1 then CF:AddMessage(datestamp1..destRT..destLink.." |cff"..hexDeath.."insta"..ACTION_UNIT_DIED.."|r "..sourceRT..sourceLink..spellLinkColor..spellIcon) end
				if optionsChatChannel>1 and KCL_Time>timeSilence then SCM(datestamp2..destRT2.."["..destName2.."] insta"..ACTION_UNIT_DIED.." "..sourceRT2.."["..sourceName2.."]"..spellLink, q, nil, r) end
			end
		end
	--	Taunts
		if optionsTaunt == true and ((instanceType ~= "party" and instanceType ~= "raid") or optionsTankTaunt == true or (optionsTankTaunt == false and isTank == false)) then -- 1) not in instance party; 2) in instance pary and option is on; 3) in instance party and source is not tank
			if (destType == 3 or destType == 4) and (spellID == 355 or spellID == 62124 or spellID == 31790 or spellID == 6795 or spellID == 56222 or spellID == 49560 or spellID == 51399 or spellID == 20736) then
				if event == "SPELL_AURA_APPLIED" then
					if optionsChatFrame>1 then CF:AddMessage(datestamp1..sourceRT..sourceLink..spellLinkColor..spellIcon.." |cff"..hexTaunt.."taunted|r "..destRT..destLink) end
					if optionsChatChannel>1 and KCL_Time>timeSilence then SCM(datestamp2..sourceRT2.."["..sourceName2.."]"..spellLink.." taunted "..destRT2.."["..destName2.."]", q, nil, r) end
			--	Taunt Missed
				elseif event == "SPELL_MISSED" and (SuffixParam1 == "MISS" or SuffixParam1 == "RESIST" or SuffixParam1 == "IMMUNE") then
					if optionsChatFrame>1 then CF:AddMessage(datestamp1..sourceRT..sourceLink..spellLinkColor..spellIcon.." on "..destRT..destLink.." |cffFF7800failed|r ("..SuffixParam1..")") end
					if optionsChatChannel>1 and KCL_Time>timeSilence then SCM(datestamp2..sourceRT2.."["..sourceName2.."]"..spellLink.."  on "..destRT2.."["..destName2.."] failed", q, nil, r) end
				end
			elseif event == "SPELL_CAST_SUCCESS" then
			--	AoE Taunt: Warrior 1161[Challenging Shoat], Druid 5209[Challenging Roar]
				if spellID == 1161 or spellID == 5209 then
					if optionsChatFrame>1 then CF:AddMessage(datestamp1..sourceRT..sourceLink..spellLinkColor..spellIcon.." AoE Taunt", self.db.profile.colorTaunt.r, self.db.profile.colorTaunt.g, self.db.profile.colorTaunt.b) end -- some variation in the coloring method :)
					if optionsChatChannel>1 and KCL_Time>timeSilence then SCM(datestamp2..sourceRT2.."["..sourceName2.."]"..spellLink.." AoE Taunt", q, nil, r) end
			--	Pet Growl: 2649[Growl], 3716[Torment], 17735[Suffering], 33698[Anguish]
				elseif optionsPetGrowl == true and sourceType == 4 and destType == 3 and (spellID == 2649 or spellID == 3716 or spellID == 17735 or spellID == 33698) then
					if optionsChatFrame>1 then CF:AddMessage(datestamp1..sourceRT..sourceLink..spellLinkColor..spellIcon.." on "..destRT..destLink) end
				end
			end
		end
	--	Interrupts
		if event == "SPELL_INTERRUPT" and optionsInterrupt == true then
			if sourceName then a = sourceLink else a = "" end
			if optionsChatFrame>1 then CF:AddMessage(datestamp1..sourceRT..a..spellLinkColor..spellIcon.." |cff"..hexInterrupt.."interrupted|r "..destRT..destLink..extraSpellLinkColor..extraSpellIcon) end
			if optionsChatChannel>1 and KCL_Time>timeSilence then SCM(datestamp2..sourceRT2.."["..sourceName2.."]"..spellLink.." interrupted "..destRT2.."["..destName2.."]"..extraSpellLink, q, nil, r) end
	--	Dispels
		elseif event == "SPELL_DISPEL" and optionsDispel == true then
			if optionsChatFrame>1 then CF:AddMessage(datestamp1..sourceRT..sourceLink..spellLinkColor..spellIcon.." |cff"..hexDispel.."dispelled|r "..destRT..destLink..extraSpellLinkColor..extraSpellIcon) end
			if optionsChatChannel>1 and KCL_Time>timeSilence then SCM(datestamp2..sourceRT2.."["..sourceName2.."]"..spellLink.." dispelled "..destRT2.."["..destName2.."]"..extraSpellLink, q, nil, r) end
	--	Spellsteals
		elseif event == "SPELL_STOLEN" and optionsDispel == true then
			if optionsChatFrame>1 then CF:AddMessage(datestamp1..sourceRT..sourceLink..spellLinkColor..spellIcon.." |cff"..hexDispel.."stole|r "..destRT..destLink..extraSpellLinkColor..extraSpellIcon) end
			if optionsChatChannel>1 and KCL_Time>timeSilence then SCM(datestamp2..sourceRT2.."["..sourceName2.."]"..spellLink.." stole "..destRT2.."["..destName2.."]"..extraSpellLink, q, nil, r) end
	--	Reflects
		elseif event == "SPELL_MISSED" and optionsReflect == true and SuffixParam1 == "REFLECT" then
			if sourceName then a = sourceLink else a = "" end
			if optionsChatFrame>1 then CF:AddMessage(datestamp1..destRT..destLink.." |cff"..hexReflect.."reflected|r "..sourceRT..a..spellLinkColor..spellIcon) end
			if optionsChatChannel>1 and KCL_Time>timeSilence then SCM(datestamp2..destRT2.."["..destName2.."] reflected "..sourceRT2.."["..sourceName2.."]"..spellLink, q, nil, r) end
	--	Resurrections
		elseif event == "SPELL_RESURRECT" and optionsResurrection == true then
			if optionsChatFrame>1 then CF:AddMessage(datestamp1..sourceRT..sourceLink..spellLinkColor..spellIcon.." |cff"..hexResurrection.."rezzed|r "..destRT..destLink) end
			if optionsChatChannel>1 and KCL_Time>timeSilence then SCM(datestamp2..sourceRT2.."["..sourceName2.."]"..spellLink.." resurrected "..destRT2.."["..destName2.."]", q, nil, r) end
	--	Crowd Control
		elseif event == "SPELL_AURA_APPLIED" and optionsCrowdControl == true then
			if spellName == "Polymorph" or spellName == "Sap" or spellName == "Shackle Undead" or spellName == "Hibernate" or spellName == "Banish" or spellName == "Freezing Trap" or spellName == "Wyvern Sting" or spellName == "Scare Beast" or spellName == "Turn Evil" or spellName == "Repentance" or spellName == "Blind" or spellName == "Hex" or spellName == "Seduction" then
				if optionsChatFrame>1 then CF:AddMessage(datestamp1..sourceRT..sourceLink..spellLinkColor..spellIcon.." |cff"..hexCrowdControl.."CC'ed|r "..destRT..destLink) end
				if optionsChatChannel>1 and KCL_Time>timeSilence then SCM(datestamp2..sourceRT2.."["..sourceName2.."]"..spellLink.." CC'ed "..destRT2.."["..destName2.."]", q, nil, r) end
			end
	--	CC Breaker
		elseif optionsCC_Break == true and ((instanceType ~= "party" and instanceType ~= "raid") or optionsTankBreaksCC == true or (optionsTankBreaksCC == false and isTank == false)) then
			if event == "SPELL_AURA_BROKEN_SPELL" then -- broken by a spell
				if sourceName then a = sourceLink; b = "["..sourceName2.."]" else a = ""; b = "" end
				if optionsChatFrame>1 then CF:AddMessage(datestamp1..sourceRT..a..extraSpellLinkColor..extraSpellIcon.." |cff"..hexCC_Break.."broke|r "..spellLinkColor..spellIcon.." on "..destRT..destLink) end
				if optionsChatChannel>1 and KCL_Time>timeSilence then SCM(datestamp2..sourceRT2..b..spellLink.." broke "..extraSpellLink.." on "..destRT2.."["..destName2.."]", q, nil, r) end
			elseif event == "SPELL_AURA_BROKEN" then -- not broken by a spell; 4.0.3a bug?: this event does not fire for CLEU
				if sourceName then
					if optionsChatFrame>1 then CF:AddMessage(datestamp1..sourceRT..sourceLink.." |cff"..hexCC_Break.."broke|r "..spellLinkColor..spellIcon.." on "..destRT..destLink) end
					if optionsChatChannel>1 and KCL_Time>timeSilence then SCM(datestamp2..sourceRT2.."["..sourceName2.."]".." broke "..spellLink.." on "..destRT2.."["..destName2.."]", q, nil, r) end
				else
					if optionsChatFrame>1 then CF:AddMessage(datestamp1..spellLinkColor..spellIcon.." on "..destRT..destLink.." |cff"..hexCC_Break.."broken|r") end
					if optionsChatChannel>1 and KCL_Time>timeSilence then SCM(datestamp2..spellLink.." on "..destRT2.."["..destName2.."] broken", q, nil, r) end
				end
			end
		end
	--	Feast, Repair Bot, Fun
		if optionsFeast == true then
			if event == "SPELL_CREATE" and
			(spellID == 87644 or -- [Seafood Magnifique Feast]
			spellID == 87643 or -- [Broiled Dragon Feast]
			spellID == 87915 or -- [Goblin Barbecue Feast]
			spellID == 57426 or -- [Fish Feast]
			spellID == 57301 or -- [Great Feast]
			spellID == 56245 or -- [Chocolate Celebration Cake]
			spellID == 57301) then -- [Lovely Cake]
				local timeBG = GetBattlefieldInstanceRunTime()
				if instanceType == "pvp" and timeBG ~= 0 and timeBG < 130000 then SCM("["..sourceName2.."] prepared a "..spellLink, "BATTLEGROUND")
				else
					if optionsChatFrame>1 then CF:AddMessage(datestamp1..sourceRT..sourceLink.." prepared a "..spellLinkColor..spellIcon) end
					if optionsChatChannel>1 and KCL_Time>timeSilence then SCM(datestamp2..sourceRT2.."["..sourceName2.."] prepared a "..spellLink, q, nil, r) end
				end
			end
		elseif optionsRepairBot == true then
			if (event == "SPELL_CREATE" and spellID == 51710) or
				(event == "SPELL_SUMMON" and spellID == 67826 or spellID == 54711) then
				if optionsChatFrame>1 then CF:AddMessage(datestamp1..sourceRT..sourceLink.." used "..spellLinkColor..spellIcon) end
				if optionsChatChannel>1 and KCL_Time>timeSilence then SCM(datestamp2..sourceRT2.."["..sourceName2.."] used "..spellLink, q, nil, r) end
			end
		elseif optionsFun == true and playerName ~= sourceName then -- dont show yourself
			if (event == "SPELL_CAST_START" and spellID == 58493) or -- S 58493[Mohawked!]
			(event == "SPELL_AURA_APPLIED" and
			(spellName == "Manabonked!" or -- 61834(NPC) / 61819(Item)
			spellID == 60122 or -- [Baby Spice]
			strfind(spellName, "Costume") or
			(strfind(spellName, "Focusing Lens") and destName ~= sourceName) or
			spellID == 27571 or -- [Cascade of Roses]  Love is in the Air
			spellID == 61815 or -- [Sprung!]  Noblegarden
			spellID == 44212 or -- [Jack-o'-Lanterned!]  Hallow's End
			spellID == 61781 or -- [Turkey Feathers]  Pilgrim's Bounty
			spellID == 44755)) or -- [Snowflakes]  Feast of Winter Veil
			(event == "SPELL_CREATE" and
			(spellID == 61031 or -- [Toy Train Set]
			spellID == 49844 or -- [Using Direbrew's Remote]
			spellID == 43808 or -- [Brewfest Pony Keg]
			spellID == 62857)) then -- [Sandbox Tiger]
				if spellID == 61031 or spellID == 49844 then SCM("["..sourceName2.."] used "..spellLink, announceType) -- Toy Train, Direbrew's Remote
				else
					if destName then a = " on "..destRT..destLink else a = "" end CF:AddMessage(datestamp1..sourceRT..sourceLink.." used "..spellLinkColor..spellIcon..a)
				end
			end
		end
	--	Class Ability
		if event == "SPELL_AURA_APPLIED" then
			if KCL_extraUpvalues(event, spellID, sourceName, destName, KCL_Time) then
				if optionsChatFrame>1 then CF:AddMessage(datestamp1..sourceRT..sourceLink.." cast "..spellLinkColor..spellIcon.." on "..destRT..destLink) end
				if optionsChatChannel>1 and spellID ~= 2096 and KCL_Time>timeSilence then SCM(datestamp2..sourceRT2.."["..sourceName2.."] cast "..spellLink.." on "..destRT2.."["..destName2.."]", q, nil, r) end
			end
		elseif event == "SPELL_CAST_SUCCESS" then
			if KCL_extraUpvalues(event, spellID, sourceName, destName, KCL_Time) then
				local timeBG = GetBattlefieldInstanceRunTime()
				if instanceType == "pvp" and timeBG ~= 0 and timeBG < 130000 then SCM("["..sourceName2.."] cast "..spellLink, "BATTLEGROUND") -- Heroism/Bloodlust/Timewarp "wasted" before bg starts; Ritual of Refreshment
				else
					if optionsChatFrame>1 then CF:AddMessage(datestamp1..sourceRT..sourceLink.." cast "..spellLinkColor..spellIcon) end
					if optionsChatChannel>1 and KCL_Time>timeSilence then SCM(datestamp2..sourceRT2.."["..sourceName2.."] cast "..spellLink, q, nil, r) end
				end
			end
		end
	end
end

function KCL_extraUpvalues(event, spellID, sourceName, destName, KCL_Time)
	if event == "SPELL_AURA_APPLIED" then
		if (spellID == 29166 and optionsInnervate == true) or
		(spellID == 34477 and optionsMisdirection == true) or
		(spellID == 54646 and optionsFocusMagic == true) or
		(spellID == 57934 and optionsTricksTrade == true) or
		(spellID == 20707 and optionsSoulstoneResurrection == true) or
		(spellID == 50720 and optionsVigilance == true) or
		(spellID == 2096 and optionsMindVision == true and destName ~= sourceName) then
		return true end
	elseif event == "SPELL_CAST_SUCCESS" then
		if ((spellID == 32182 or spellID == 2825 or spellID == 80353) and optionsBloodlust == true and KCL_Time > cd_Bloodlust) then cd_Bloodlust = KCL_Time + 130 return true end
		if (spellID == 43987 and optionsRitualRefreshment == true and KCL_Time > cd_RitualRefreshment) then cd_RitualRefreshment = KCL_Time + 130 return true end
	end
end

	-------------------------
	-----  END OF ADDON ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- ----- -----
	-------------------------
--[[
# Version History
	v0.90 [2010.11.29]	Completely rewrote and optimized code; Renamed from [Ketho Combat] to [Ketho CombatLog]
						Updated to Ace3 r981 [2010.10.27], from r907 [2009.12.16]
						Added: Advanced options for Coloring & Icons, Raid Target Icons (if assigned to unit)
						Added: Chat Commands; Type "/ket help" for more info
						Removed: Boss/Battleground Mods, Instance Timer
						Improved localization (used strings from GlobalStrings.lua whenever possible)
						Now properly implement "Unit Links" for Shift-left-clicking and right-clicking them
	v0.71 [2010.04.16]	Added: Profiles
	v0.70 [2010.01.21]	Added: GUI options, properly embeded the Ace3 libraries now
	r1	  [2009.11.24]	Initial Release (very noob coded ><)
						This AddOn was inspired by Taunt Tattle from casualcorp @Curse
# Links
	AddOn: Curse			http://wow.curse.com/downloads/wow-addons/details/ketho-combat.aspx
	Ladik's MPQ Editor		http://zezula.net/en/mpq/download.html
	BLP2PNG					http://www.wowinterface.com/downloads/info6127-BLP2PNG.html
--]]